<?php
/*  em  31-08-2020 */
class EnterpriseuserModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';

            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){ /*em 31-08-20 */
    
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ent_user_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $cli = new Enterpriseuser(); 
                //$cli->__SET('sede_id', $r->sede_id);
                $cli->__SET("Id",  $r->Id);
                $cli->__SET("EnterpriseId",  $r->EnterpriseId);
                $cli->__SET("UserId",  $r->UserId);
                $cli->__SET("IsDefault",  $r->IsDefault);
                $cli->__SET("Status",  $r->Status);
                $cli->__SET("CreationUser",  $r->CreationUser);
                $cli->__SET("CreationDate",  $r->CreationDate);
                $cli->__SET("UpdateUser",  $r->UpdateUser);
                $cli->__SET("UpdateDate",  $r->UpdateDate); 
                $cli->__SET("eName",  $r->eName);
                $cli->__SET("uName",  $r->uName); 
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($sede_id){ /* em 31-08-20 */
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ent_user_listar($sede_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $cli = new Enterpriseuser(); 
                //$cli->__SET('sede_id', $r->sede_id);
                $cli->__SET("Id",  $r->Id);
                $cli->__SET("EnterpriseId",  $r->EnterpriseId);
                $cli->__SET("UserId",  $r->UserId);
                $cli->__SET("IsDefault",  $r->IsDefault);
                $cli->__SET("Status",  $r->Status);
                $cli->__SET("CreationUser",  $r->CreationUser);
                $cli->__SET("CreationDate",  $r->CreationDate);
                $cli->__SET("UpdateUser",  $r->UpdateUser);
                $cli->__SET("UpdateDate",  $r->UpdateDate); 
                $cli->__SET("eName",  $r->eName);
                $cli->__SET("uName",  $r->uName); 
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarUser(){ /*em 31-08-20 */
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL user_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $data = new User();
			    		 $data->__SET("Id",  $r->Id);
			    		 $data->__SET("Name",  $r->Name);
			    		 $data->__SET("Login",  $r->Login);
			    		 $data->__SET("Password",  $r->Password);
			    		 $data->__SET("UserTypeId",  $r->UserTypeId);
			    		 $data->__SET("Status",  $r->Status);
			    		 $data->__SET("CreationUser",  $r->CreationUser);
			    		 $data->__SET("CreationDate",  $r->CreationDate);
			    		 $data->__SET("UpdateUser",  $r->UpdateUser);
			    		 $data->__SET("UpdateDate",  $r->UpdateDate);             
                		 $result[] = $data;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarRoller(){ /*em 31-08-20 */
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL role_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $data = new User();
			    		 $data->__SET("Id",  $r->Id);
			    		 $data->__SET("Name",  $r->Name);
                		 $result[] = $data;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function BuscarUser($sede_id){ /* em 31-08-20 */
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL user_listar($sede_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $data = new User();
                        $data->__SET("Id",  $r->Id);
			    		 $data->__SET("Name",  $r->Name);
			    		 $data->__SET("Login",  $r->Login);
			    		 $data->__SET("Password",  $r->Password);
			    		 $data->__SET("UserTypeId",  $r->UserTypeId);
			    		 $data->__SET("Status",  $r->Status);
			    		 $data->__SET("CreationUser",  $r->CreationUser);
			    		 $data->__SET("CreationDate",  $r->CreationDate);
			    		 $data->__SET("UpdateUser",  $r->UpdateUser);
			    		 $data->__SET("UpdateDate",  $r->UpdateDate);             
                		 $result[] = $data;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
   
    public function Crear(Enterpriseuser $data){ /* EM 31-08-2020 */
        try {
            $stm = $this->pdo->prepare("CALL ent_user_crear(?,?,?,?, @sede_id)"); 
            $stm->execute(array(
                                 //$data->__get('sSede'),
                                 $data->__get("EnterpriseId"),
                                 $data->__get("UserId"),
                                 $data->__get("IsDefault"),
                                 $data->__get("Status"),
                                 ));

                                 foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                                    $sede_id = $r->sede_id;
                                }
                                return $sede_id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(Enterpriseuser $data){ /* em 31-08-2020 */
  
        try {
            $stm = $this->pdo->prepare("CALL ent_user_editar(?,?,?,?,?)");
            $stm->execute(array(
                            $data->__get("Id"),
                            $data->__get("EnterpriseId"),
                            $data->__get("UserId"),
                            $data->__get("IsDefault"),
                            $data->__get("Status"),
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function CrearRole(Roleenterpriseuser $data){ /* EM 31-08-2020 */
        try {
            $stm = $this->pdo->prepare("CALL role_ent_crear(?,?,?, @sede_id)"); 
            $stm->execute(array(
                                 //$data->__get('sSede'),
                                 $data->__get("EnterpriseuserId"),
                                 $data->__get("RoleId"),
                                 $data->__get("Status"),
                                 ));

                                 foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                                    $sede_id = $r->sede_id;
                                }
                                return $sede_id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function EditarRole(Roleenterpriseuser $data){ /* em 31-08-2020 */
  
        try {
            $stm = $this->pdo->prepare("CALL role_ent_editar(?,?,?,?)");
            $stm->execute(array(
                            $data->__get("Id"),
                            $data->__get("EnterpriseuserId"),
                                 $data->__get("RoleId"),
                                 $data->__get("Status"),
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Enterpriseuser $data){ /* em 02-09-20 */
    
        try {
             $stm = $this->pdo->prepare("CALL sed_eliminar(?)");
             $stm->execute(array($data->__get('sede_id')));
        } catch (Exception $e) {
             echo die($e->getMessage());
        }
   }
   public function VerificarCodCliExiste($sCliCodigo){
    //,$_POST["sEntVIN"]
    try {
        $result = array();
        $stm = $this->pdo->prepare("CALL role_validarCOD($sCliCodigo)");
        $stm->execute();
        foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
            $mov = array(
                'EnterpriseuserId' => $r->EnterpriseuserId,
                'Id' => $r->Id,
            );
            $result[] = $mov;
        }
        return $result;
    } catch (Exception $e) {
        echo die($e->getMessage());
    }
}

}
?>
