var garantias = (function(garantias, undefined){
    
    var _table = $('#example1'),
        _changes = function(){
                        
            $('#Protocologe_Id').on('changed.bs.select', function (e) {
                
                $("#Cliente_Id").selectpicker('val', $(this).find('option:selected').data('codigo'));
                
            });

            // $('#nGarAnio').on('changed.bs.select', function (e) {
                
            //     var dGarFechaActivacion = $("#dGarFechaActivacion").val();

            //     if(dGarFechaActivacion != ""){
                    
            //         var dateAct = dGarFechaActivacion.split("-"),
            //             anio = parseInt(dateAct[2]) + parseInt(e.target.value), 
            //             datepicker = $('.dGarFecha');

            //         datepicker.data('DateTimePicker').date(dateAct[0] + '-' + dateAct[1] + '-' + anio);
                    
            //     } else {
                    
            //         $("#resultado").ATDmessage({
            //             type: 'warning',
            //             header: 'Advertencia',
            //             message: 'Debe de seleccionar una fecha de activación.'
            //         });
                    
            //         $(this).selectpicker("val", "");
                    
            //     }
            // });

        },
        _Limpiar = function(){
            $('#Garantia_Id').val("0");
            $('#Protocologe_Id').selectpicker("val", "");
            $('#Cliente_Id').selectpicker("val", "");
            $('#dGarFechaActivacion').val("");
            $('#nGarAnio').selectpicker("val", "1");
            $('#dGarFecha').val("");
            $('#sGarCodigoActivacion').val("");
            $('#sGarpadron').val("");
        },
        _callbackDoneListar = function(data){

            $("#example1 tbody").html(data);
        
        },
        _callbackAlwaysListar = function(){
            garantias.dataTable();
            _showModal();
            _editar();
        },  
        
        _showModal = function(){

            $('#modal-eliminar').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                
                var modal = $(this)
                modal.find('.modal-body input').val(codigo)
            })

        },
        
        _editar = function(){
            $(".editar").click(function(){

                myApp.ajax({
                
                    uurl: "?c=Garantias&a=Buscar",
                    data: {Entrega_Id: $(this).data('codigo'),
                            FechaInicio: $("#FechaInicio").val(),
                            FechaFin: $("#FechaFin").val()},
                    callbackDone: _callbackDoneEditar
                
                }); 
            
            });
            
        },
        
        _callbackDoneEditar = function(data){
            
            $('#Protocologe_Id').prop('disabled', true);
            
            $("#Garantia_Id").val(data[0].Garantias_Id)
            $("#Protocologe_Id").selectpicker("val", data[0].Protocologe_Id)
            $("#Cliente_Id").selectpicker("val", data[0].Cliente_Id)
            $("#dGarFechaActivacion").val(myApp.dateDDMMYYYY(data[0].dGarFechaActivacion, '-'))
            $("#nGarAnio").selectpicker("val", data[0].nGarAnio)
            $("#dGarFecha").val(myApp.dateDDMMYYYY(data[0].dGarFecha, '-'));
            $("#sGarCodigoActivacion").val(data[0].sGarCodigoActivacion);
            $("#sGarpadron").val(data[0].sGarpadron); /* em  01-10-2020 */
            $("#modal-nuevo").modal("show");
        };

    garantias.editar = function(){

        $(".editar").click(function(){
            //alert($("#FechaFin").val());

                myApp.ajax({
                
                    url: "?c=Garantias&a=Buscar",
                    data: {Garantias_Id: $(this).data('codigo'),
                            FechaInicio: $("#FechaInicio").val(),
                            FechaFin: $("#FechaFin").val()},
                    callbackDone: _callbackDoneEditarUno
                }); 
            
            });
    },
    _callbackDoneEditarUno = function(data){
            //$('#Protocologe_Id').prop('disabled', true);
            $("#Garantias_Id").val(data[0].Garantias_Id);
            //$("#Entrega_Id").selectpicker("val", data[0].Entrega_Id);
            
            
            $("#nGarUsuarioDis_Id").selectpicker("val", data[0].Distribuidor_Id);
            $("#pro_producto").val(data[0].sModNombre);
            $("#sGarCodigoActivacion").val(data[0].sEntNroMotor);
            $("#sGarCodigoActivacion2").val(data[0].sGarPlacaRodaje);
            $("#dGarFechaActivacion").val(data[0].dGarFechaActivacion);
            $("#nGarAnio").selectpicker("val", data[0].nGarMeses);
            $("#dGarFecha").val(data[0].dGarFechaVencimiento);
            $("#sGarpadron").val(data[0].sGarpadron); /* em  01-10-2020 */
            if (data[0].sGarAdjunto!='' && data[0].sGarAdjunto!='n/a') {
                $("#content-file-reclamos").html(
                    '<a class="form-control" href="uploads/'+data[0].sGarAdjunto+'" target="_blank">'+data[0].sGarAdjunto+'</a>'
                );
            }

            if ($("#Garantias_Id").val()!=0) {
                listarDisEdit();
            }
            //$("#Entrega_Id").val(data[0].Entrega_Id);
            //$("#Cliente_Id").val(data[0].Cliente_Id);
            $("#modal-nuevo").modal("show");

        };
    garantias.eliminar = function(){
        $('#modal-eliminar').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                
                var modal = $(this)
                modal.find('.modal-body input').val(codigo)
            });
    },
    
    garantias.clickFiltrar = function(){
        
        $(".filtrar").click(function(){
            
            if($("#FrmFiltrar").valid()){
            
                _table.dataTable().fnClearTable();
                _table.dataTable().fnDestroy();

                 myApp.ajax({

                    url: "?c=Garantias&a=Index",
                    data: {
                        FechaInicio: $("#FechaInicio").val(),
                        FechaFin: $("#FechaFin").val()
                    },
                    dataType : "html",
                    callbackDone: _callbackDoneListar,
                    callbackAlways: _callbackAlwaysListar

                }); 
                
            }
        });
        
    },
    
    garantias.picker = function(){
        
        $('.dGarFecha, .dGarFechaActivacion, #FechaInicio, #FechaFin ').datetimepicker({
            defaultDate: '01/01/2017',
            format: 'DD-MM-YYYY'
        });
                
        $(".selectPicker").selectpicker({  
            size: 5,
            liveSearch: true
        });
                
        _changes();
        
    },
    
    garantias.clickSave = function(){
        
        $("#GuardarGarantias").click(function(){
            
            if($("#FrmGuardarGarantias").valid()){
                
                $.ajax({
                    url: '?c=Garantias&a=GuardarGarantia',
                    data: {
                        "Garantias_Id"          : $('#Garantias_Id').val(),
                        "Entrega_Id"          : $('#Entrega_Id').val(),
                        "nGarUsuarioDis_Id"          : $('#nGarUsuarioDis_Id').val(),          
                        "Cliente_Id"           : $('#Cliente_Id').val(),
                        "sGarPlacaRodaje"            : $('#sGarCodigoActivacion2').val(),
                        "dGarFechaActivacion"               : $('#dGarFechaActivacion').val(),
                        "nGarMeses"               : $('#nGarAnio').val(),
                        "sGarpadron"               : $('#sGarpadron').val(),    /* em  01-10-2020 */
                        "dGarFechaVencimiento"  : $('#dGarFecha').val()
                    },
                    type: 'POST',
                    success: function(data){

                        _Limpiar();
                        // $("#resultado").ATDmessage({
                        //     header: 'Exito',
                        //     message: 'Los datos fueron guardados correctamente'
                        // });
                        $("#resultado").html(data);
                        $('html, body').animate({scrollTop: '0px'}, 1000);
                        
                        //_table.dataTable().fnClearTable();
                        //_table.dataTable().fnDestroy();
                        
                        //garantias.listar();
                        
                        // var estado = <?php echo $estado; ?>
                        // if (estado==1) {
                        //     alert("Seguiré en la página");
                        // }else{
                        //     if (estado==2) {
                        //         alert("Saldré de la página");
                        //     }
                        // }
                        window.location.href = '?c=Garantias&a=Index';
                        var estados= $("#Estado").val();
                        if (estados==1) {}else{if (estados==2) {$("#modal-nuevo").hide();}}
                    }
                });
                
            }
            
        });
        
    },
    
    garantias.validar = function(){
        $.validator.addMethod("modasaDate", function (value, element) {
            return value.match(/^\d\d?\-\d\d?\-\d\d\d\d$/);
        }, "Please enter a date in the format dd-mm-yyyy.");
        
        $("#FrmGuardarGarantias").validate({
            errorClass: 'error',
            rules: {  
                nGarUsuarioDis_Id: {
                   required: true
                },
                Entrega_Id: {
                   required: true
                },
                Cliente_Id: {
                   required: true
                },
                sGarCodigoActivacion2: {
                   required: true
                }
            },
            messages: {        
                nGarUsuarioDis_Id: "Campo Requerido.",
                Entrega_Id: "Campo Requerido.",
                Cliente_Id: "Campo Requerido.",
                sGarCodigoActivacion2: "Campo Requerido."
            }
        });
        
    },
    
    garantias.validarFiltro = function(){
        $.validator.addMethod("modasaDate", function (value, element) {
            return value.match(/^\d\d?\-\d\d?\-\d\d\d\d$/);
        }, "Please enter a date in the format dd-mm-yyyy.");
        
        $("#FrmFiltrar").validate({
            rules: {
                FechaInicio: {
                    required: true,
                    modasaDate: true
                },
                FechaFin: {
                    required: true,
                    modasaDate: true
                }
            },
            messages: {
                FechaInicio: {
                    required: "Ingresar fecha por favor.",
                    modasaDate: "Fecha invalida."
                },
                FechaFin: {
                    required: "Ingrese fecha por favor.",
                    modasaDate: "Fecha invalida."
                }
            }
        });
        
    },
    
    garantias.modalHide = function(){
        $('#modal-nuevo').on('hide.bs.modal', function () {
            
            $('#Protocologe_Id').prop('disabled', false);
            $('#resultado').html("");
            
        });
    },
    
    garantias.listar = function(){
        
        myApp.ajax({

            url: "?c=Entregas&a=Index",
            //data: json,
            dataType : "html",
            contentType: "text/html; charset=utf-8",
            callbackDone: _callbackDoneListar,
            callbackAlways: _callbackAlwaysListar

         }); 
        
    },

    garantias.addFileReclamos = function(){
        $("#btn-file-reclamos").click(function(){
            var files= $("#FileReclamos").val();

            var files1 = document.getElementById('FileReclamos'+(i-1));

            if ( typeof(files1) != 'undefined' && files1 != null ) {files=$("#FileReclamos"+(i-1)).val();}

            if (files.indexOf("á")!=-1 || files.indexOf("é")!=-1 || files.indexOf("í")!=-1 || files.indexOf("ó")!=-1 || files.indexOf("ú")!=-1 || files.indexOf("ñ")!=-1 || files.indexOf("ä")!=-1 
                || files.indexOf("ë")!=-1 || files.indexOf("ï")!=-1 || files.indexOf("ö")!=-1 || files.indexOf("ü")!=-1 || files.indexOf("Á")!=-1 || files.indexOf("É")!=-1 || files.indexOf("Í")!=-1 || files.indexOf("Ó")!=-1 || files.indexOf("Ú")!=-1 || files.indexOf("Ñ")!=-1 || files.indexOf("Ä")!=-1 
                || files.indexOf("Ë")!=-1 || files.indexOf("Ï")!=-1 || files.indexOf("Ö")!=-1 || files.indexOf("Ü")!=-1 || files.indexOf("·")!=-1) {alert("El archivo contiene caracteres no válidos. Seleccione otro archivo."); $("#preloader").hide();}else{

            alert("Se ha adjuntado archivo.");
            var i = $(this).data("cant");
            
            var xhtml = '';
            xhtml += '<div class="row">';
            xhtml += '    <div class="col-sm-8">';
            xhtml += '        <div class="row" id="content-seguimiento-file"> ';
            xhtml += '            <div class="col-sm-12 form-group">';
            xhtml += '                <input type="file" class="eFile" name="FileReclamos[]" id="FileReclamos' + i + '" style="width: 100%;">';
            xhtml += '            </div>';
            xhtml += '        </div>';
            xhtml += '    </div>';
            xhtml += '    <div class="col-sm-4 text-right">';
            xhtml += '       <a href="#" class="btn btn-danger limpiar-input-file-reclamos" data-codigo="' + i + '"><i class="fa fa-times" aria-hidden="true"></i></a>';
            xhtml += '       <button type="button" class="btn btn-danger btn-input-file-delete">ELIMINAR</button>';
            xhtml += '    </div>';
            xhtml += '</div>';

            $("#content-file-reclamos").append(xhtml);
            
            $(this).data( "cant", i + 1 );
            
            garantias.removeFileInput();

            garantias.limpiarInputFile();

            }

        });
    },
    garantias.removeFileInput = function(){

        $(".btn-input-file-delete").click(function(){

            $(this).parent().parent().remove();

        });

    },
    garantias.limpiarInputFile = function(){

        $(".limpiar-input-file").click(function(){

            var codigo = $(this).data('codigo');

           $("#FileSeguimiento" + (codigo != undefined ? "_" + codigo : '')).val("");

        });

        $(".limpiar-input-file-reclamos").click(function(){

            var codigo = $(this).data('codigo');
            
           $("#FileReclamos" + (codigo != undefined ? codigo : '')).val("");

        });

    },
    garantias.dataTable = function(){
        /*
        jQuery.fn.dataTableExt.oSort['fecha-asc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            //return ((x < y) ? -1 : ((x > y) ? 1 : 0));
            
        };

        jQuery.fn.dataTableExt.oSort['fecha-desc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            //return ((x < y) ? 1 : ((x > y) ? -1 : 0));
            
        };
                
        _table.dataTable();
        */
    };
    
    return garantias;
})(garantias || {});

$(function(){
    
    //garantias.listar();
    garantias.picker();
    garantias.validar();
    garantias.validarFiltro();
    garantias.clickSave();
    //garantias.clickFiltrar();
    garantias.modalHide();
    $("#nGarAnio").selectpicker("val", "1");
    
    garantias.dataTable();
    //garantias.addFileReclamos();
    garantias.editar();
    garantias.eliminar();
    

});