$("#nRecDetCantidad").keypress( function(e) {
    var chr = String.fromCharCode(e.which);
    if ("0123456789.".indexOf(chr) < 0)
        return false;
});

$("#sRecDetHoras").keypress( function(e) {
    var chr = String.fromCharCode(e.which);
    if ("0123456789.:".indexOf(chr) < 0)
        return false;
});

jQuery.validator.addMethod("letras", function (value, element) {
    return this.optional(element) || /^[a-záéóóúàèìòùäëïöüñ\s]+$/i.test(value);
});
jQuery.validator.addMethod("decimales", function (value, element) {
    return this.optional(element) || /^([,0-9]+\.+[0-9]|[0-9])+$/.test(value);
});
jQuery.validator.addMethod("fecha", function (value, element) {
    return this.optional(element) || /^([0-9]{2}\/[0-9]{2}\/[0-9]{4})$/.test(value);
});
jQuery.validator.addMethod("password_modasa", function (value, element) {
    return this.optional(element) || /^(?=.*[a-zA-Z])(?=.*\d)(?=.*[$@$!%*?&#.$($)$-$_])([A-Za-z\d$@$!%*?&#.$($)$-$_]|[^ ]){6,8}$/.test(value);
//    return this.optional(element) || /^[A-zA-Z]\w{6,8}$/.test(value);
});
//
//$("#FrmClientes").validate({
//    errorClass: 'error',
//    rules: {    
//        sCliCodigoSAP: {
//            required: true,
//            maxlength: 50
//        },
//        sCliNombre: {
//            required: true,
//            maxlength: 70          
//        },
//        sCliRUCDNI: {
//            required: true,
//            digits: true,
//            maxlength: 12,
//            minlength: 8
//        },
//        sCliTelefono: {
//            required: true,
//            digits: true,
//            maxlength: 11,
//            minlength: 9
//        },
//        sCliTelefono2: {
//            required: true,
//            digits: true,
//            maxlength: 11,
//            minlength: 9
//        },
//        sCliCodPais: {
//            required: true,
//            maxlength: 50
//        },
//        sCliPais: {
//            required: true,
//            maxlength: 50
//        },
//        sCliDepartamento: {
//            required: true,
//            maxlength: 50
//        },
//        sCliProvincia: {
//            required: true,
//            maxlength: 50
//        },
//        sCliDistrito: {
//            required: true,
//            maxlength: 50
//        },
//        sCliDireccion: {
//            required: true,
//            maxlength: 50
//        },
//        sCliUsuario: {
//            required: true,
//            maxlength: 100
//        },
//        sCliPassword: {
//            required: true,
//            maxlength: 100
//        },
//        sCliGrupoCli: {
//            required: true,
//            maxlength: 100
//        },
//        nCliEstado: {
//            required: true
//        }
//    },
//    messages: {  
//        sCliCodigoSAP: {
//            required: "Ingrese Codigo SAP.",
//            maxlength: "Maxmimo 50 Caracteres."
//        },
//        sCliNombre: {
//            required: "Ingrese nombre.",
//            maxlength: "Maximo 50 Caracteres."          
//        },
//        sCliRUCDNI: {
//            required: "Ingrese DNI/RUC.",
//            digits: "Permitido solo numeros.",
//            maxlength: "Maximo 12 Caracteres.",
//            minlength: "Minimo 8 Caracteres."
//        },
//        sCliTelefono: {
//            required: "Ingrese Telefono 1.",
//            digits: "Permitido solo numeros.",
//            maxlength: "Maximo 12 Caracteres.",
//            minlength: "Minimo 8 Caracteres."
//        },
//        sCliTelefono2: {
//            required: "Ingrese Telefono 2.",
//            digits: "Permitido solo numeros.",
//            maxlength: "Maximo 12 Caracteres.",
//            minlength: "Minimo 8 Caracteres."
//        },
//        sCliCodPais: {
//            required: "Ingrese Codigo Pais",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliPais: {
//            required: "Ingrese Pais.",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliDepartamento: {
//            required: "Ingrese Departamento.",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliProvincia: {
//            required: "Ingrese Provincia.",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliDistrito: {
//            required: "Ingrese Distrito.",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliDireccion: {
//            required: "Ingrese Dirección.",
//            maxlength: "Maximo 50 Caracteres."
//        },
//        sCliUsuario: {
//            required: "Ingrese Usuario.",
//            maxlength: "MAximo 100 Caracteres."
//        },
//        sCliPassword: {
//            required: "Ingrese Password.",
//            maxlength: "Maximo 100 Caracteres."
//        },
//        sCliGrupoCli: {
//            required: "Ingrese Grupo.",
//            maxlength: "Maximo 100 Caracteres."
//        },
//        nCliEstado: {
//            required: "Seleccione Estado."
//        }
//    }
//});

$("#formProducto").validate({
    errorClass: 'error',
    rules: {    
        nTipo: {
            required: true
        },         
        sproDescripcion: {
            required: true,
            maxlength: 45
        },
        sTPrMarca: {
            required: true,
            maxlength: 50
        },
        sTPrModelo: {
            required: true,
            maxlength: 50
        },
        sTPrPotencia: {
            required: true,
            maxlength: 50
        },
        sTPrAlternador: {
            required: true,
            maxlength: 50
        },
        sTPrTipoGobernacion: {
            required: true,
            maxlength: 50
        },
        sTPrTipoAspiracion: {
            required: true,
            maxlength: 50
        },
        nTPrPrimeKVA: {
            required: true,
            decimales: true
        },
        nTPrStandByKVA: {
            required: true,
            decimales: true
        },
        nProTipo: {
            required: true
        }
    },
    messages: {  
        nTipo: {
            required: "Seleccione tipo"
        },         
        sproDescripcion: {
            required: "Ingrese descripción.",
            maxlength: "Maximo 45 Caracteres"
        },
        sTPrMarca: {
            required: "Ingrese Marca.",
            maxlength: "Maximo 50 Caracteres."
        },
        sTPrModelo: {
            required: "Ingrese Modelo.",
            maxlength: "Maximo 50 Caracteres."
        },
        sTPrPotencia: {
            required: "Ingrese Potencia",
            maxlength: "Maximo 50 Caracteres."
        },
        sTPrAlternador: {
            required: "Ingrese Alternador.",
            maxlength: "Maximo 50 Caracteres."
        },
        sTPrTipoGobernacion: {
            required: "Ingrese Gobernacion",
            maxlength: "Maximo 50 Caracteres"
        },
        sTPrTipoAspiracion: {
            required: "Ingrese Aspiracion.",
            maxlength: "Maximo 50 Caracteres"
        },
        nTPrPrimeKVA: {
            required: "Ingrese Prime KVA",
            decimales: "Permitido solo decimales."
        },
        nTPrStandByKVA: {
            required: "Ingrese Stand by KVA.",
            decimales: "Permitido solo decimales."
        }
    }
    
});


$("#FrmPersonal").validate({
    
    errorClass: 'error',
    rules: {    
        sPerApePaterno: {
            required: true,
            maxlength: 45
        },
        sPerApeMaterno: {
            required: true,
            maxlength: 45
        },
        sPerNombres: {
            required: true,
            maxlength: 45
        },
        sPerDNI:{
            required: true, //"Ingrese DNI/RUC.",
            digits: true, //"Permitido solo numeros.",
            maxlength: 8, //"Maximo 8 Caracteres.",
            minlength: 8 //"Minimo 8 Caracteres."
        },
        sPerCargo:{
            required: true
        },
        nPerEstado:{
            required: true
        }
    },
    messages: {  
        sPerApePaterno: {
            required: "Ingrese Apellido Paterno",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerApeMaterno: {
            required: "Ingrese Apellido Materno.",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerNombres: {
            required: "Ingrese Nombres.",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerDNI:{
            required: "Ingrese DNI/RUC.",
            digits: "Permitido solo numeros.",
            maxlength: "Maximo 8 Caracteres.",
            minlength: "Minimo 8 Caracteres."
        },
        sPerCargo:{
            required: "Ingrese Cargo.",
        },
        nPerEstado:{
            required: "Seleccione Estado"
        }
    }
});

$("#FrmBien").validate({
    errorClass: 'error',
    rules: {        
        sBienPlaca: {            
           required: true
        },
        sBienCategoria: {
            required: true
        },
        sBienMarca: {
            required: true
        },
        sBienModelo: {
            required: true
        },
        sBienAnioFabricacion: {
            required: true,
            digits: true
        },
        sBienVINSeria: {
            required: true
        },
        sBienCombustible: {
            required: true
        },
        sBienNumeroMotor: {
            required: true
        },
        nBienNumeroRuedas: {
            required: true,
            digits: true
        },
        nBienEstado: {
            required: true
        }
    },
    messages: {        
        sBienPlaca: "Ingrese placa de rodaje.",
        sBienCategoria: "Ingrese categoria",
        sBienMarca: "Ingrese marca.",
        sBienModelo: "Ingrese modelo",
        sBienAnioFabricacion: {
            required: "Ingrese año de fabricacion",
            digits: "Ingrese solo numeros."
        },
        sBienVINSeria: "Ingrese VIN/serie",
        sBienCombustible: "Ingrese combustible.",
        sBienNumeroMotor: "Ingrese numero de motor.",
        nBienNumeroRuedas: {
            required: "Ingrese numero de eje",
            digits: "Ingrese solo numeros"
        },
        nBienEstado: "Ingrese estado por favor"
    }
});
$("#FrmGarantiasM").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdM: {            
           required: true
        },
        sMobCiudadM: {
            required: true
        },
        sGarNroNotariaM: {
//            required: true,
            digits: true
        },
        dGarFechaM: {
            required: true
        },
        dMobValorBienM: {
            required: true,
            decimales: true
        },
        dGarFinancimientoM: {
//            required: true,
            decimales: true
        },
        dGarValorAfectacionM: {
//            required: true,
            decimales: true
        },
        dGarValorConvecionalM: {
//            required: true,
            decimales: true
        },
        nGarTipomonedaM: {
            required: true
        },
        nGarEstadoM: {
            required: true
        }
    },
    messages: {        
        Notaria_IdM: "Seleccione Notaria.",
        sMobCiudadM: "Seleccione ciudad.",
        sGarNroNotariaM: {
//            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaM: "Ingrese fecha.",
        dMobValorBienM: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoM: {
//            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionM: {
//            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        dGarValorConvecionalM: {
//            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaM: "Seleccione tipo de moneda.",
        nGarEstadoM: "Seleccione estado"
    }
});
$("#FrmGarantiasI").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdI: {            
           required: true
        },
        sInmCiudadI: {
            required: true
        },
        sGarNroNotariaI: {
            digits: true
        },
        dGarFechaI: {
            required: true
        },
        dInmValorBienI: {
            required: true,
            decimales: true
        },
        dGarFinancimientoI: {
            required: true,
            decimales: true
        },
        dGarValorAfectacionI: {
            required: true,
            decimales: true
        },
        nGarTipomonedaI: {
            required: true
        },
        dGarValorConvecionalI: {
            required: true,
            decimales: true
        },
        nGarEstadoM: {
            required: true
        },
        sInmDepartamentoI: {
            required: true
        },
        sInmProvinciaI: {
            required: true
        },
        sInmDistritoI: {
            required: true
        },
        nGarEstadoI: {
            required: true
        }
    },
    messages: {        
        Notaria_IdI: "Seleccione Notaria.",
        sInmCiudadI: "Seleccione ciudad.",
        sGarNroNotariaI: {
            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaI: "Ingrese fecha.",
        dInmValorBienI: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoI: {
            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionI: {
            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaI: "Seleccione tipo de moneda.",
        dGarValorConvecionalI: {
            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarEstadoM: "Seleccione estado",
        sInmDepartamentoI: "Seleccione departamento.",
        sInmProvinciaI: "Seleccione provincia.",
        sInmDistritoI: "Seleccione distrito",
        nGarEstadoI: "Seleccione estado"
    }
});
$("#FrmGarantiasO").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdO: {            
           required: true
        },
        nOtrTipoO: {
            required: true
        },
        sGarNroNotariaO: {
            digits: true
        },
        dGarFechaO: {
            required: true
        },
        nOtrMontoGarantizadoO: {
            required: true,
            decimales: true
        },
        dGarFinancimientoO: {
            required: true,
            decimales: true
        },
        dGarValorAfectacionO: {
            required: true,
            decimales: true
        },
        nGarTipomonedaO: {
            required: true
        },
        dGarValorConvecionalO: {
            required: true,
            decimales: true
        },
        nOtrRegistradoO: {
            required: true
        },
        nGarEstadoO: {
            required: true
        }
    },
    messages: {        
        Notaria_IdO: "Seleccione Notaria.",
        nOtrTipoO: "Seleccione ciudad.",
        sGarNroNotariaO: {
            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaO: "Ingrese fecha.",
        nOtrMontoGarantizadoO: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoO: {
            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionO: {
            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaO: "Seleccione tipo de moneda.",
        dGarValorConvecionalO: {
            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarEstadoO: "Seleccione estado.",
    }
});

$("#FrmNotaria").validate({
    errorClass: 'error',
    rules: {        
        sNotNombre: {            
           required: true
        },
        nNotTelefono: {
           required: true
        },
        sNotDireccion: {
           required: true
        },
        nNotEstado: {
           required: true
        }
    },
    messages: {        
        sNotNombre: "Ingrese Nombres",
        nNotTelefono: "Ingrese Telefonos",
        sNotDireccion: "Ingrese Direccion",
        nNotEstado: "Por favor seleccione estado."
    }
});
$("#FrmVendedor").validate({
    errorClass: 'error',
    rules: {        
        nVenDNI: {            
           required: true
        },
        sVenNombres: {
           required: true
        },
        sVenApellidoPaterno: {
           required: true
        },
        sVenApellidoMaterno: {
           required: true
        },
        sVenTelefono: {
           required: true
        },
        nVenCorreo: {
           required: true
        },
        sVenDomicilio: {
           required: true
        },
        nVenEstado: {
           required: true
        }
    },
    messages: {        
        nVenDNI: "Ingrese DNI",
        sVenNombres: "Ingrese nombre",
        sVenApellidoPaterno: "Ingrese Apellido Paterno.",
        sVenApellidoMaterno: "Ingrese Apellido Materno.",
        sVenTelefono: "Ingrese telefono.",
        nVenCorreo: "Ingrese correo",
        sVenDomicilio: "Ingrese domicilio",
        nVenEstado: "seleccione estado."
    }
});
$("#FrmUsuario").validate({
    errorClass: 'error',
    rules: {        
        nombre: {            
           required: true,
           letras: true
        },
        login: {
           required: true
        },
        contraseñaOne: {
           required: true,
           //password_modasa: true
        },
        contraseñaTwo: {
           required: true,
           equalTo: "#contraseñaOne",
           //password_modasa: true
        },
        tipo: {
           required: true
        },
        estado: {
           required: true
        }
    },
    messages: {        
        nombre: "Ingrese nombre valido solo letras.",
        login: "Ingrese login porfavor.",
        contraseñaOne: {
            required: "Ingrese contraseña que utilizara.",
            password_modasa: "Constraseña no segura tener en cuenta (Letras, números, caracteres especiales y longitud entre 6 – 8 caracteres)"
        },
        contraseñaTwo: {
            required: "Por favor ingrese nuevamente la contraseña.",
            equalTo: "Las contraseñas no coinciden",
            password_modasa: "Constraseña no segura tener en cuenta (Letras, números, caracteres especiales y longitud entre 6 – 8 caracteres)"
        },
        tipo: "seleccione el tipo de usuario.",
        estado: "seleccione estado"
    }
});
$('#FrmFinancimiento').validate({ // initialize the plugin
    ignore: [],
    rules: {
        Cliente_Id: {
            required: true
        },
        Vendedor_Id: {
            required: true
        },
//        nFinAnio: {
//            required: true,
//            digits: true
//        },
//        dFinGravamen: {
//            required: true,
//            digits: true
//        },
        nFinEstado: {
            required: true
        }
    },
    messages: {        
        Cliente_Id: "<small class='selectpicker_items'>* Ingrese nombre valido solo letras.</small>",
        Vendedor_Id: "<small class='selectpicker_items'>* Ingrese nombre valido solo letras.</small>",
//        nFinAnio: "<small class='selectpicker_items'>* Ingrese nombre valido solo numeros.</small>",
//        dFinGravamen: "<small class='selectpicker_items'>Ingrese nombre valido solo letras.</small>",
        nFinEstado: "<small class='selectpicker_items'>Ingrese nombre valido solo letras.</small>"
    },
    submitHandler: function (form) { // for demo
//        alert('valid form submitted'); // for demo
        return true; // for demo
    }
});


//jQuery.validator.setDefaults({
//  debug: true,
//  success: "valid"
//});
//var form = $( "#FrmComposicionFamiliar" );
//form.validate();
//$( "#Agregar" ).click(function() {
//  alert( "Valid: " + form.valid() );
//});



$("#FrmProtocologe").validate({
    errorClass: 'error',
    rules: {        
        pro_numero_one: {            
           required: true
        },
        pro_numero_two: {
           required: true
        }
    },
    messages: {        
        pro_numero_one: "",
        pro_numero_two: "Ingrese nombre"
    }
});

$("#FrmClientes").validate({
    errorClass: 'error',
    rules: {    
        Distribuidor_Id: {            
           required: true
        },    
        Cliente_Id: {            
           required: true
        },
        sCliNombre: {
           required: true
        },
        sCliRUCDNI: {
           required: true
        },
        sCliPais: {
           required: true
        }
    },
    messages: {
        Distribuidor_Id: "Seleccione el distribuidor.",        
        Cliente_Id: "Escoja un cliente.",
        sCliNombre: "Ingrese un nombre.",
        sCliRUCDNI: "Ingrese Ruc/Dni.",
        sCliPais: "Ingrese el país/región."
    }
});

$("#FrmRepuestos").validate({ /* em 05-09-2020  valida repuestos*/
    errorClass: 'error',
    rules: {    
        sRepCodigo: {            
           required: true
        },    
        sRepuesto: {            
           required: true
        },
        nRepCosto: {
           required: true
        },
    },
    messages: {
        sRepCodigo: "Ingrese un código.",
        sRepuesto: "Ingrese un nombre.",
        nRepCosto: "Ingrese un  precio."
    }
});
$("#FrmTecnicos").validate({
    errorClass: 'error',
    rules: {  
        sPerCodigo: {
           required: true
        },
        sPerDNI: {
           required: true
        },
        sPerApePaterno: {
           required: true
        },
        sPerNombres: {
           required: true
        },
        sPerCargo: {
           required: true
        },
    },
    messages: {        
        sPerCodigo: "Ingrese un código.",
        sPerDNI: "Ingrese DNI.",
        sPerApePaterno: "Ingrese Apellido paterno.",
        sPerNombres: "Ingrese un nombre.",
        sPerCargo: "Ingrese un cargo."
    }
});
$("#FrmDistribuidor").validate({
    errorClass: 'error',
    rules: {  
        sDisNombre: {
           required: true
        },
        sDisRUCDNI: {
           required: true
        },
        nDisGarantiaMeses: {
           required: true
        },
        nDisCostoMO: {
           required: true
        },
        nDisValorKM: {
           required: true
        },
        sDisPais: {
           required: true
        }
    },
    messages: {        
        sDisNombre: "Ingrese un nombre.",
        sDisRUCDNI: "Ingrese Ruc/Dni.",
        nDisGarantiaMeses: "Ingrese cantidad de meses de garnatía.",
        nDisCostoMO: "Ingrese costo por mano de obra ($).",
        nDisValorKM: "Ingrese valor de KM ($).",
        sDisPais: "Ingrese País/Regíon."
    }
});
$("#FrmGuardarGarantias").validate({
    errorClass: 'error',
    rules: {  
        sGarCodigoActivacion: {
           required: true
        },
        Cliente_Id: {
           required: true
        },
        pro_producto: {
           required: true
        },
        sGarCodigoActivacionMotor: {
           required: true
        },
        sEntFactura: {
           required: true
        }
    },
    messages: {        
        sGarCodigoActivacion: "Campo Requerido.",
        Cliente_Id: "Campo Requerido.",
        pro_producto: "Campo Requerido.",
        sGarCodigoActivacionMotor: "Campo Requerido.",
        sEntFactura: "Campo Requerido."
    }
});
$("#FrmProveedor").validate({
    errorClass: 'error',
    rules: {  
        sPrvNombre: {
           required: true
        },
        sPrvRUCDNI: {
           required: true
        }
    },
    messages: {        
        sDisNombre: "Ingrese un nombre.",
        sDisRUCDNI: "Ingrese Ruc/Dni."
    }
});

function validarEmail(elemento){  /*funcion para validar el correo*/
    var texto = document.getElementById(elemento.id).value;
var regex = /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;
if (texto.length == 0){
    document.getElementById("resultadosa").innerHTML = "";
    return;
}
if (!regex.test(texto)) {
    document.getElementById("resultadosa").innerHTML = "Correo invalido";
} else {
  document.getElementById("resultadosa").innerHTML = "";
}

}