var reclamos = (function(reclamos, undefined){
    
    var _table = $('#example1'),
        _changes = function(){
                        
            $('#Protocologe_Id').on('changed.bs.select', function (e) {
                
                $("#Cliente_Id").selectpicker('val', $(this).find('option:selected').data('codigo'));
                
            });

        },
        _Limpiar = function(){
            $('#Reclamos_Id').val("0");
            $('#Protocologe_Id').selectpicker("val", "");
            $('#Cliente_Id').selectpicker("val", "");
            $('#dRecFecha').val("");
            $('#dRecDescripcion').val("");
            $("#Protocologe_Id").selectpicker("show");
            $("#sRecEquipoOtros").hide();
            $("#sRecEquipoOtros").val("");
            $("#otros_equipos").attr("checked", false);
            
        },
        _callbackDoneListar = function(data){

            $("#example1 tbody").html(data);
        
        },
        _callbackAlwaysListar = function(){
            reclamos.dataTable();
            //_editar();
        },  

        _callbackDoneEditar = function(data){

            if(data[0].Protocologe_Id == '0'){

                $("#Protocologe_Id_edit").hide();
                $("#sRecEquipoOtros_edit").show();

            } else {

                $("#Protocologe_Id_edit").show();
                $("#sRecEquipoOtros_edit").hide();

            }

            $("#Reclamos_Id_Cerrar").val(data[0].Reclamos_Id);
            $("#Protocologe_Id_edit").val(data[0].Protocologe_Id);
            $("#Cliente_Id_edit").val(data[0].Cliente_Id);
            $("#dRecFecha_edit").val(myApp.dateDDMMYYYY(data[0].dRecFecha, '-'));
            $("#dRecDescripcion_edit").val(data[0].dRecDescripcion);
            $("#sRecEquipoOtros_edit").val(data[0].sRecEquipoOtros);
            
            _ListarSeguimientos(data[0].Reclamos_Id);
            $("#lista-documentos").html(_ListarImages(data[0].Reclamos_Id));

        },

        _callbackAlwaysGuardarSeguimiento = function(){
            
            $("#resultado_seguimiento").ATDmessage({
                header: 'Exito',
                message: 'Los datos fueron guardados correctamente'
            });

            _ListarSeguimientos(this.parameters[0]);
        },
        
        _callbackAlwaysListarSeguimientos = function(data){

            var html = '';
            
            for(var i = 0 ; i < data.length ; i++){
                
                html += '<div class="box-comments" style="border-bottom: 1px solid #f4f4f4; padding-bottom: 10px; margin-bottom: 10px;">';
                html += '   <div class="box-comment">';
                html += '       <div class="comment-text">';
                html += '           <span class="username">';
                html += '           <b>' + (data[i].nRecTipo != 0 ? data[i].sUsuNombre : data[i].sCliNombre) + '</b><br>';
                html += '           <span class="text-muted pull-right text-bold">'+ data[i].sRecDetFechaAct + '</span>';
                html += '           </span>';
                html += '           ' + data[i].sRecDetDescripcion;
                html += '           ' + _ListarImages(data[i].Reclamos_detalle_Id);
                html += '       </div>';
                html += '   </div>';
                html += '</div>';
                
            }
            
            $("#lista_resultado").html(html);
            
        },
        
        
        _ListarImages = function(reclamos_id){

            var html = "";

            $.ajax({
                url: '?c=Reclamos&a=MostrarImagenes',
                type: "post",
                data: {Reclamos_id: reclamos_id},
                async: false,
                success: function(data){
                    html = data;
                }
            });

            return html;
        };
    
    reclamos.picker = function(){
        
        $('.dRecFecha ').datetimepicker({
            defaultDate: '01/01/2017',
            format: 'DD-MM-YYYY'
        });
                
        $(".selectPicker").selectpicker({  
            size: 5,
            liveSearch: true
        });
                
        _changes();
        
    },
    
    reclamos.clickSave = function(){
        
        $("#GuardarReclamos").click(function(e){
            
            e.defaultPrevented;
            
            if($("#FrmGuardarReclamos").valid()){                

                $("#preloader").show();
                
                var formData = new FormData(document.getElementById("FrmGuardarReclamos"));
                
                formData.append('Reclamos_Id', $("#Reclamos_Id").val());
                formData.append('Protocologe_Id', ($("#otros_equipos").is(":checked") == false ? $('#Protocologe_Id').val() : 0));
                formData.append('Equipo_Id', ($("#otros_equipos").is(":checked") == false ? $('#Protocologe_Id option:selected').data('equipo') : 0));
                formData.append('Cliente_Id', $("#Cliente_Id").val());
                formData.append('dRecFecha', $("#dRecFecha").val());
                formData.append('dRecDescripcion', $("#dRecDescripcion").val());
                formData.append('sRecEquipoOtros', ($("#otros_equipos").is(":checked") == true ? $("#sRecEquipoOtros").val() : ''));
                
                /*
                var jsonData = {};
        
                jsonData.Reclamos_Id         = $('#Reclamos_Id').val(),
                jsonData.Protocologe_Id      = ($("#otros_equipos").is(":checked") == false ? $('#Protocologe_Id').val() : 0),
                jsonData.Equipo_Id           = ($("#otros_equipos").is(":checked") == false ? $('#Protocologe_Id option:selected').data('equipo') : 0),
                jsonData.Cliente_Id          = $('#Cliente_Id').val(),
                jsonData.dRecFecha           = $('#dRecFecha').val(),
                jsonData.dRecDescripcion     = $('#dRecDescripcion').val(),
                jsonData.sRecEquipoOtros     = ($("#otros_equipos").is(":checked") == true ? $("#sRecEquipoOtros").val() : '');
                */  
                $.ajax({
                    url: '?c=Reclamos&a=Guardar',
                    data: formData,
                    type: "post",
                    data: formData,
                    cache: false,
                    dataType: "text",
                    contentType: false,
                    processData: false,
                    success: function(data){
                        _Limpiar();
                        $("#resultado").ATDmessage({
                            header: 'Exito',
                            message: 'Los datos fueron guardados correctamente'
                        });
                        
                        _table.dataTable().fnClearTable();
                        _table.dataTable().fnDestroy();
                        
                        reclamos.listar();

                        $("#preloader").hide();
                        $("#FileReclamos").val("");
                        $("#content-file-reclamos").html("");

                        $("#preloader").hide();

                        $("#modal-nuevo").hide();
                    }
                });
                
            }
            
        });
        
    },
    
    reclamos.validar = function(){
        $.validator.addMethod("modasaDate", function (value, element) {
            return value.match(/^\d\d?\-\d\d?\-\d\d\d\d$/);
        }, "Please enter a date in the format dd-mm-yyyy.");
        
        $("#FrmGuardarReclamos").validate({
            rules: {
                Protocologe_Id: {
                    required: true
                },
                Cliente_Id: {
                    required: true
                },
                dRecFecha: {
                    required: true,
                    modasaDate: true
                },
                dRecDescripcion: {
                    required: true
                }
            },
            messages: {
                Protocologe_Id: {
                    required: "Debe de seleccionar un equipo por favor."
                },
                Cliente_Id: {
                    required: "Debe de seleccionar un cliente por favor."
                },
                dRecFecha: {
                    required: "Ingresar fecha por favor.",
                    modasaDate: "Fecha invalida."
                },
                dRecDescripcion: {
                    required: "Ingrese descripción por favor."
                }
            }
        });
        
    },
    
    reclamos.validarSeguimiento = function(){
        $("#FrmSeguimientoAgregar").validate({
            rules: {
                sRecDetDescripcion: {
                    required: true
                }
            },
            messages: {
                sRecDetDescripcion: {
                    required: "Debe de ingresar descripción por favor."
                }
            }
        });
        
    },
    
    reclamos.modalHide = function(){
        $('#modal-nuevo').on('hide.bs.modal', function () {
            
            $('#resultado').html("");
            
        });
    },
    
    reclamos.listar = function(){
        
        myApp.ajax({

            url: "?c=Reclamos&a=RepUltReclamos2",
            //data: json,
            dataType : "html",
            contentType: "text/html; charset=utf-8",
            callbackDone: _callbackDoneListar,
            callbackAlways: _callbackAlwaysListar

         }); 
        
    },
    
    
    reclamos.addSeguimiento = function(){
        
        $("#btn-add-seguimiento").click(function(){
            
            if($("#FrmSeguimientoAgregar").valid()){
                
                myApp.ajax({

                    url: "?c=Reclamos&a=GuardarSeguimiento",
                    data: {
                        Reclamos_Id_edit: $("#Reclamos_Id_Cerrar").val(),
                        sRecDetDescripcion: $("#sRecDetDescripcion").val(),
                        Cliente_Id_edit: $("#Cliente_Id_edit").val()
                    },
                    parameters: [$("#Reclamos_Id_Cerrar").val()],
                    type: 'POST',
                    callbackAlways: _callbackAlwaysGuardarSeguimiento

                }); 
                
            }
            
        });
        
    },
    
    reclamos.dataTable = function(){
        
        jQuery.fn.dataTableExt.oSort['fecha-asc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        };

        jQuery.fn.dataTableExt.oSort['fecha-desc'] = function(a, b) {
            var ukDatea = a.split('-');
            var ukDateb = b.split('-');

            var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
            var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

            return ((x < y) ? 1 : ((x > y) ? -1 : 0));
        };
                
        _table.dataTable();
        
    },

    reclamos.changeOtrosReclamos = function(){

        $("#otros_equipos").change(function(){

            if($(this).is(":checked")){

                $("#Protocologe_Id").selectpicker("hide");
                $("#sRecEquipoOtros").show();

            } else {

                $("#Protocologe_Id").selectpicker("show");
                $("#sRecEquipoOtros").hide();

            }

        });

    },

    reclamos.showModal = function(){

            $('#modal-eliminar').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                
                var modal = $(this)
                modal.find('.modal-body input').val(codigo)
            });

            $('#modal-seguimiento').on('show.bs.modal', function (event) {

                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                var estado = button.data('estado');

                if(estado == 1){

                    $("#sRecDetDescripcion").attr("disabled", true);
                    $("#btn-add-seguimiento").attr("disabled", true);
                    $("#btn-add-file-input").attr("disabled", true);
                    $("input[name='FileSeguimiento[]']").attr("disabled", true);

                }else{

                    $("#sRecDetDescripcion").attr("disabled", false);
                    $("#btn-add-seguimiento").attr("disabled", false);
                    $("#btn-add-file-input").attr("disabled", false);
                    $("input[name='FileSeguimiento[]']").attr("disabled", false);

                }

                myApp.ajax({
                
                    url: "?c=Reclamos&a=Filter",
                    data: {Garantia_Id: codigo},
                    callbackDone: _callbackDoneEditar

                }); 

            });

            $('#modal-rechazar').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget);
                var codigo = button.data('codigo');
                
                var modal = $(this)
                modal.find('.modal-body input').val(codigo)
            });

            $("#modal-cerrar-reclamo").on('show.bs.modal', function (event) {

                var button = $(event.relatedTarget);
                var codigo = button.data("codigo");
                
                $("#Reclamos_Id_Cerrar_modal").val(codigo);

            });

            $("#modal-aperturar-reclamo").on('show.bs.modal', function(event){

                var button = $(event.relatedTarget);
                var codigo = button.data("codigo");

                $("#Reclamos_Id_Aperturar_modal").val(codigo);

            });

        },

    reclamos.addFileReclamos = function(){

        $("#btn-add-file-input").click(function(){
            alert("Se ha adjuntado archivo.");
            var i = $(this).data("cant");
            
            var xhtml = '';
            xhtml += '<div class="row">';
            xhtml += '    <div class="col-sm-9">';
            xhtml += '        <div class="row" id="content-seguimiento-file"> ';
            xhtml += '            <div class="col-sm-12 form-group">';
            xhtml += '                <input type="file" class="eFile" name="FileSeguimiento[]" id="FileSeguimiento_' + i + '">';
            xhtml += '            </div>';
            xhtml += '        </div>';
            xhtml += '    </div>';
            xhtml += '    <div class="col-sm-3">';
            //xhtml += '       <a href="#" class="btn btn-danger limpiar-input-file" data-codigo="' + i + '"><i class="fa fa-times" aria-hidden="true"></i></a>';
            xhtml += '       <button type="button" class="btn btn-danger btn-input-file-delete">ELIMINAR</button>';
            xhtml += '    </div>';
            xhtml += '</div>';

            $("#content-file-input").append(xhtml);
            
            $(this).data( "cant", i + 1 );
            
            reclamos.removeFileInput();

            reclamos.limpiarInputFile();

        });

        $("#btn-file-reclamos").click(function(){
            alert("Se ha adjuntado archivo.");
            var i = $(this).data("cant");
            
            var xhtml = '';
            xhtml += '<div class="row">';
            xhtml += '    <div class="col-sm-8">';
            xhtml += '        <div class="row" id="content-seguimiento-file"> ';
            xhtml += '            <div class="col-sm-12 form-group">';
            xhtml += '                <input type="file" class="eFile" name="FileReclamos[]" id="FileReclamos' + i + '" style="width: 100%;">';
            xhtml += '            </div>';
            xhtml += '        </div>';
            xhtml += '    </div>';
            xhtml += '    <div class="col-sm-4 text-right">';
            xhtml += '       <a href="#" class="btn btn-danger limpiar-input-file-reclamos" data-codigo="' + i + '"><i class="fa fa-times" aria-hidden="true"></i></a>';
            xhtml += '       <button type="button" class="btn btn-danger btn-input-file-delete">ELIMINAR</button>';
            xhtml += '    </div>';
            xhtml += '</div>';

            $("#content-file-reclamos").append(xhtml);
            
            $(this).data( "cant", i + 1 );
            
            reclamos.removeFileInput();

            reclamos.limpiarInputFile();

        })

    },

    reclamos.removeFileInput = function(){

        $(".btn-input-file-delete").click(function(){

            $(this).parent().parent().remove();

        });

    },
    
    reclamos.uploadFile = function(){
        
        $("#btn-add-seguimiento-ejemp").click(function(e){
           
            e.defaultPrevented;
            
            $("#preloader").show();
            
            var formData = new FormData(document.getElementById("FrmSeguimientoAgregar"));
            
            formData.append('Reclamos_Id_Cerrar', $("#Reclamos_Id_Cerrar").val());

            formData.append('Cliente_Id_edit', $("#Cliente_Id_edit").val());

            formData.append('Protocologe_Id_edit', $("#Protocologe_Id_edit").val());
            
            $.ajax({
                url: '?c=Reclamos&a=Ejemplos',
                type: "post",
                data: formData,
                cache: false,
                dataType: "text",
                contentType: false,
                processData: false,
                async: false,
                success: function(res){
                    
                    $("#resultado_seguimiento").html(res);

                },
                error: function(err){
                    
                    console.log(err);
                    
                },
                complete: function()
                {
                    
                    _ListarSeguimientos($("#Reclamos_Id_Cerrar").val());
                    $("#preloader").hide();
                    $("#FileSeguimiento").val("");
                    $("#sRecDetDescripcion").val("");
                    $("#content-file-input").html("");
                    $("#modal-seguimiento").hide();
                }
                
            });
        })
    },
    reclamos.limpiarInputFile = function(){

        $(".limpiar-input-file").click(function(){

            var codigo = $(this).data('codigo');

           $("#FileSeguimiento" + (codigo != undefined ? "_" + codigo : '')).val("");

        });

        $(".limpiar-input-file-reclamos").click(function(){

            var codigo = $(this).data('codigo');
            
           $("#FileReclamos" + (codigo != undefined ? codigo : '')).val("");

        });

    };
    
    return reclamos;
})(reclamos || {});

$(function(){
    
    reclamos.listar();
    reclamos.picker();
    reclamos.validar();
    reclamos.validarSeguimiento();
    reclamos.clickSave();
    reclamos.modalHide();
    //reclamos.addSeguimiento();
    reclamos.changeOtrosReclamos();
    reclamos.showModal();
    reclamos.addFileReclamos();
    reclamos.uploadFile();
    reclamos.limpiarInputFile();
    
});

function ListarSeguimiento(reclamo_id){
    //alert(reclamo_id);
    $.post('?c=Reclamos&a=ListarSeguimiento',{
        
            Reclamos_Id: reclamo_id
        
        },function(data){
            
           var data=JSON.parse(data);
           $("#resultado_seguimiento").html('');
        });


}
