<?php
header('Access-Control-Allow-Origin: *'); 
require_once 'model/enterprise.entidad.php';
require_once 'model/enterprise.model.php';

//require_once 'model/distribuidor.entidad.php';
//require_once 'model/distribuidor.model.php';

//require_once 'model/distribuidor_contacto.entidad.php';
//require_once 'model/distribuidor_contacto.model.php';

//require_once 'model/usuario.entidad.php';
//require_once 'model/usuario.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
//require_once 'model/apoderado.model.php';
//require_once 'model/apoderado.entidad.php';
ini_set('max_execution_time', 500);
class EnterpriseController extends helpers
{
    private $enterprise_model;

    //private $distribuidor_model;
    //private $distribuidor_contacto_model;
    //private $usuario_model;
    private $parametro_model;
    //private $apoderado_model;

    public function __CONSTRUCT()
    {
        $this->enterprise_model = new EnterpriseModel();

        //$this->distribuidor_model = new DistribuidorModel();
        //$this->distribuidor_contacto_model = new Distribuidor_contactoModel();
        //$this->usuario_model = new UsuarioModel();
        //$this->parametro_model = new ParametroModel();
        //$this->apoderado_model = new ApoderadoModel();

    }

    public function Index()
    {
        //$parametro = $this->parametro_model->ListarParametros();
        $clientes = $this->enterprise_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfaenterprise.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
    public function FrmGuardarProveedor()
    {
        //require_once 'view/webforms/wfaproveedora.php'; 
        require_once 'view/webforms/wfaenterprise_a.php';
    }

    public function FrmEditarProveedor()
    {
        $datos = $this->enterprise_model->Buscar($_POST['Id']);
        foreach ($datos as $r) :
            require_once 'view/webforms/wfaenterprise_a.php';
        endforeach;
    }

    public function MostrarCliente()
    {
        $datos = $this->enterprise_model->Buscar($_POST['Id']);
        foreach ($datos as $r) :
            echo " <tbody>
                              <tr>
                                 <td>
                                    <input type='hidden' name='idCliente_Print' id='idCliente_Print' value='" . $r->__GET('Id') . "'> 
                                    Codigo SAP
                                 </td>
                                 <td>" . $r->__GET('Code') . "</td>
                              </tr>
                              <tr>
                                 <td>Nombre/Razon social</td>
                                 <td>" . $r->__GET('Name') . "</td>
                              </tr> 
                              <tr>
                                 <td>RUC/DNI</td>
                                 <td>" . $r->__GET('TradeName') . "</td>
                              </tr>  
                              <tr>
                                 <td>RUC/</td>
                                 <td>" . $r->__GET('Ruc') . "</td>
                              </tr>  
                              <tr>
                                 <td>Direccion</td>
                                 <td>" . $r->__GET('Address') . "</td>
                              </tr>  
                              <tr>
                                 <td>UbigeoName</td>
                                 <td>" . $r->__GET('UbigeoName') . "</td>
                              </tr>   
                              <tr>
                                 <td>UbigeoCode</td>
                                 <td>" . $r->__GET('UbigeoCode') . "</td>
                              </tr>    
                              <tr>
                                 <td>CTADetraccion</td>
                                 <td>" . $r->__GET('CTADetraccion') . "</td>
                              </tr>   
                              <tr>
                                 <td>NameDB</td>
                                 <td>" . $r->__GET('NameDB') . "</td>
                              </tr>  
                              <tr>
                                 <td>UsuarioDB</td>
                                 <td>" . $r->__GET('UsuarioDB') . "</td>
                              </tr>  
                              <tr>
                                 <td>PasswordDB</td>
                                 <td>" . $r->__GET('PasswordDB') . "</td>
                              </tr>
                              <tr>
                                 <td>ServerDB</td>
                                 <td>" . $r->__GET('ServerDB') . "</td>
                              </tr>
                              <tr>
                                 <td>ExoneratedIGV</td>
                                 <td>" . $r->__GET('ExoneratedIGV') . "</td>
                              </tr>
                              <tr>
                                 <td>Notification</td>
                                 <td>" . $r->__GET('Notification') . "</td>
                              </tr>
                              <tr>
                                 <td>Estado</td>
                                 <td>" . ($r->__GET('Status') == 0 ? '<span class="label label-danger">Deshabilitado</span>' : '<span class="label label-success">Habilitado</span>') . "</td>
                              </tr>
                              
                              </tbody>";
        endforeach;
    }
    public function GuardarProveedor()
    {
        $dis = new Enterprise();
        if ($_POST['Id'] != 0 ? $dis->__SET('Id', $this->str_uppercase($_POST['Id'])) : '');
        $dis->__SET("Code",  $_POST["Code"]);
        $dis->__SET("Name",  $_POST["Name"]);
        $dis->__SET("TradeName",  $_POST["TradeName"]);
        $dis->__SET("Ruc",  $_POST["Ruc"]);
        $dis->__SET("Address",  $_POST["Address"]);
        $dis->__SET("UbigeoName",  $_POST["UbigeoName"]);
        $dis->__SET("UbigeoCode",  $_POST["UbigeoCode"]);
        $dis->__SET("CTADetraccion", $_POST["CTADetraccion"]);
        $dis->__SET("NameDB",  $_POST["NameDB"]);
        $dis->__SET("UsuarioDB",  $_POST["UsuarioDB"]);
        $dis->__SET("PasswordDB",  $_POST["PasswordDB"]);
        $dis->__SET("ServerDB",  $_POST["ServerDB"]);
        $dis->__SET("Email",  $_POST["Email"]);
        $dis->__SET("Seal",  $_POST["Seal"]);
        $dis->__SET("IsFE",  $_POST["IsFE"]);
        $dis->__SET("Background",  $_POST["Background"]);
        $dis->__SET("ExoneratedIGV",  $_POST["ExoneratedIGV"]);
        $dis->__SET("HasResend",  $_POST["HasResend"]);
        $dis->__SET("Notification",  $_POST["Notification"]);
        $dis->__SET("Status", $_POST["Status"]);
        $dis->__SET("UpdateUser",  $_SESSION['usu_codigo']);

        if ($_POST['Id'] != 0) {
            $this->enterprise_model->Editar($dis);
        } else {
            $Proveedor_Id = $this->enterprise_model->Crear($dis);
        }
        //echo $Proveedor_Id ;
        echo '<div class="alert alert-success alert-dismissable">
            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
            <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
            ' . ($_POST['Id'] != 0 ? 'Se modificó correctamente.' : 'Se guardo correctamente.') . '
          </div>';
        if ($_POST['Id'] == 0) {
            echo '<script type="text/javascript">window.location="?c=Enterprise&a=Index";</script>';
        }
    }
    public function EliminarCliente()
    {
        echo '<script type="text/javascript">window.location="?c=Enterprise&a=Index";</script>';
        return;
        $cli = new Enterprise();
        $cli->__SET('Proveedor_Id', $_POST['Id']);
        $cli->__SET('nPrvUsuario_Id', $_SESSION['usu_codigo']);
        $this->enterprise_model->Eliminar($cli);
        echo '<script type="text/javascript">window.location="?c=Enterprise&a=Index";</script>';
    }

    public function PDFCliente()
    {
        require_once 'view/webforms/PDF/cliente.php';
    }
    public function ListarContactos()
    {

        $contactos = $this->distribuidor_contacto_model->Buscar($_POST['Cliente_Id']);

        $array = [];

        foreach ($contactos as $r) :

            $array[] = array(
                'distribuidor_contacto_Id' => $r->distribuidor_contacto_Id,
                'distribuidor_Id' => $r->distribuidor_Id,
                'sdisConNombre' => $r->sdisConNombre,
                'sdisConCargo' => $r->sdisConCargo,
                'sdisConCorreo' => $r->sdisConCorreo,
                'sdisConMovil' => $r->sdisConMovil
            );

        endforeach;

        print_r(json_encode($array));
    }

    public function ImportarExcel()
    {

        if (substr($_FILES['excel_clientes']['name'], -4) == "xlsx") {

            $fecha = date("y-m-d");
            $carpeta = "view/librerias/excel/";
            $excel = $fecha . "-" . $_FILES["excel_clientes"]["name"];
            move_uploaded_file($_FILES["excel_clientes"]["tmp_name"], $carpeta . $excel);

            $pathInfo = pathinfo($carpeta . $excel);

            $type = $pathInfo['extension'] == 'xlsx' ? 'Excel2007' : 'Excel5';

            $objReader = PHPExcel_IOFactory::createReader($type);

            $objPHPExcel = $objReader->load($carpeta . $excel);

            foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {

                $worksheets[$worksheet->getTitle()] = $worksheet->toArray();
            }
            if (isset($worksheets["Sheet1"])) {

                $data = $worksheets["Sheet1"];

                for ($i = 0; $i < count($data); $i++) {

                    $json = $data[$i];

                    $verificar = $this->clientes_model->Verificar($json[0]);

                    if (count($verificar) == 0) {

                        $cli = new Clientes();
                        $cli->__SET('sCliCodigoSAP', $json[0]);
                        $cli->__SET('sCliNombre', $json[1]);
                        $cli->__SET('sCliRUCDNI', $json[11]);
                        $cli->__SET('sCliTelefono', $json[2]);
                        $cli->__SET('sCliTelefono2', $json[2]);
                        $cli->__SET('sCliCodPais', $json[4]);
                        $cli->__SET('sCliPais', $json[5]);
                        $cli->__SET('sCliDepartamento', $json[6]);
                        $cli->__SET('sCliProvincia', $json[7]);
                        $cli->__SET('sCliDistrito', $json[8]);
                        $cli->__SET('sCliDireccion', $json[9]);
                        $cli->__SET('sCliUsuario', "");
                        $cli->__SET('sCliPassword', "");
                        $cli->__SET('sCliGrupoCli', $json[10]);
                        $cli->__SET('nCliEstado', 1);
                        $cli->__SET('nCliOculto', 0);
                        $cli->__SET('nCliUsuario_Id', $_SESSION['usu_codigo']);

                        $Cliente_Id = $this->clientes_model->Crear($cli);

                        if ($json[12] != "") {

                            $cont = new Cliente_contacto();
                            $cont->__SET("Cliente_Id", $Cliente_Id);
                            $cont->__SET("sCliConNombre", $json[12]);
                            $cont->__SET("sCliConCargo", "");
                            $cont->__SET("sCliConCorreo", $json[14]);
                            $cont->__SET("sCliConMovil", "");
                            $this->clientes_contacto_model->Crear($cont);
                        }

                        if ($json[13] != "") {

                            $cont1 = new Cliente_contacto();
                            $cont1->__SET("Cliente_Id", $Cliente_Id);
                            $cont1->__SET("sCliConNombre", $json[13]);
                            $cont1->__SET("sCliConCargo", "");
                            $cont1->__SET("sCliConCorreo", $json[14]);
                            $cont1->__SET("sCliConMovil", "");
                            $this->clientes_contacto_model->Crear($cont1);
                        }
                    }
                }

                echo "Datos guardados";
                echo '<script type="text/javascript">window.location="?c=Cliente&a=Index";</script>';
            }
        }

        echo '<script type="text/javascript">window.location="?c=Cliente&a=Index";</script>';

        //print_r();


        //            $fecha = date("y-m-d");
        //            $carpeta = "view/librerias/excel/";
        //            $excel = $fecha."-".$_FILES["excel_clientes"]["name"];
        //            move_uploaded_file($_FILES["excel_clientes"]["tmp_name"], $carpeta.$excel);
        //            
        //            $row = 1;
        //            
        //            $fp = fopen($carpeta.$excel, "r");
        //            
        //            while ($data = fgetc($fp, 1000, ",")){
        //                echo $data[0];
        //            }
        //            
        //            echo substr($_FILES["excel_clientes"]["name"], -3);

    }
    public function JsonDatosCliente()
    {

        $datos = $this->clientes_model->Buscar($_POST["Cliente_Id"]);
        foreach ($datos as $r) :
            print_r(json_encode(array(
                'Cliente_Id' => $r->Cliente_Id,
                'sCliCodigoSAP' => $r->sCliCodigoSAP,
                'sCliNombre' => $r->sCliNombre,
                'sCliRUCDNI' => $r->sCliRUCDNI,
                'sCliTelefono' => $r->sCliTelefono,
                'sCliTelefono2' => $r->sCliTelefono2,
                'sCliCodPais' => $r->sCliCodPais,
                'sCliPais' => $r->sCliPais,
                'sCliDepartamento' => $r->sCliDepartamento,
                'sCliProvincia' => $r->sCliProvincia,
                'sCliDistrito' => $r->sCliDistrito,
                'sCliDireccion' => $r->sCliDireccion,
                'sCliUsuario' => $r->sCliUsuario,
                'sCliPassword' => $r->sCliPassword,
                'sCliGrupoCli' => $r->sCliGrupoCli,
                'nCliEstado' => $r->nCliEstado,
                'nCliOculto' => $r->nCliOculto,
                'dCliFecha_Act' => $r->dCliFecha_Act,
                'nCliUsuario_Id' => $r->nCliUsuario_Id
            )));
        endforeach;
    }

    /* em 09-11-20  cheka q exista codigo */
    public function VerificarCodCliExiste()
    {
        $ent = $this->enterprise_model->VerificarCodCliExiste($_POST["Cliente_Id"], $_POST["sCliCodSAP"]);
        echo json_encode($ent);
    }
    /* em 09-11-20  cheka q exista dni */
    public function VerificarRucCliExiste()
    {
        $ent = $this->enterprise_model->VerificarRucCliExiste($_POST["Cliente_Id"], $_POST["sCliRUCDNI"]);
        echo json_encode($ent);
    }



    public function ListarComprobantes()
    {

        $comprobantes =  $this->enterprise_model->ObtenerComprobantes();
        require_once 'view/header.php';
        require_once 'view/webforms/wfacomprobantes.php';
        require_once 'view/footer.php';
    }

    public function ObtenerEmpresaPorRuc()
    {
        $ruc = $_REQUEST["ruc"];
        $credenciales =  $this->enterprise_model->ObtenerEmpresaPorRuc($ruc);
        echo json_encode($credenciales);
    }

    public function ReenviarComprobantes()
    {

        $empresas =  $this->enterprise_model->ObtenerEmpresas();

        require_once 'view/header.php';
        require_once 'view/webforms/wfaverificarcomprobante.php';
        require_once 'view/footer.php';
    }

    public function ObtenerIdMovimientos()
    {
        $dbname = $_POST["dbname"];
        $empresas = $this->enterprise_model->getMovimientos($dbname);
        echo $empresas;
    }
}
