<?php
/*
require_once 'model/usuario.entidad.php';
require_once 'model/usuario.model.php';
require_once 'model/distribuidor_usuario.entidad.php'; /*em 26-08-2020*/
/*
require_once 'model/distribuidor_usuario.model.php'; 
require_once 'model/ubigeo.entidad.php';
require_once 'model/ubigeo.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/bitacorausuario.model.php';
require_once 'model/bitacorausuario.entidad.php';
require_once 'model/clientes.model.php';
require_once 'model/clientes.entidad.php';
require_once 'model/reporte.model.php';
require_once 'model/distribuidor.model.php';
require_once 'model/distribuidor.entidad.php';

require_once 'model/protocologe.entidad.php';
require_once 'model/protocologe.model.php';

require_once 'model/fm_constantes.model.php';
require_once 'model/fm_constantes.entidad.php';
*/
/*em*/


class PrincipalController
{
    private $usuario_model;
    private $ubigeo_model;
    private $parametro_model;
    private $bitacorausuario_model;
    private $reporte_model;
    private $fm_constantes_model;
    private $clientes_model;
    private $protocologe_model;
    private $distribuidor_model;
    private $distibuidor_usuario_model; /*em 08-08-2020 */

    public function __construct()
    {
        /*
        $this->usuario_model = new UsuarioModel();
        $this->distibuidor_usuario_model = new Distribuidor_usuarioModel(); /*em 29-08-20*/
        /*
        $this->ubigeo_model = new UbigeoModel();
        $this->parametro_model = new ParametroModel();
        $this->bitacorausuario_model = new BitacorausuarioModel();
        $this->reporte_model = new ReporteModel();
        $this->fm_constantes_model = new Fm_constantesModel();
        $this->clientes_model = new ClientesModel();
        $this->protocologe_model = new ProtocologeModel();
        $this->distribuidor_model = new DistribuidorModel();
        */
    }

    function diff_dte($date1, $date2)
    {
        if (!is_integer($date1)) $date1 = strtotime($date1);
        if (!is_integer($date2)) $date2 = strtotime($date2);
        return floor(abs($date1 - $date2) / 60 / 60 / 24);
    }

    public function PDFControlCalidad()
    {

        $r = $this->controlcalidad_model->Buscar($_GET["cal_num"]);

        require_once 'view/webforms/PDF/controlcalidad.php';
    }
    public function NombreProtocolo($Protocologe_Id)
    {
        $protocologe = $this->protocologe_model->BuscarId($Protocologe_Id);
        return (count($protocologe) > 0 ? ($protocologe[0]["pro_numero"] . " | " . $protocologe[0]["sCliNombre"]) : "");
    }

    public function verificarFechaClave($fecha)
    {
        $fechaActual = date("Y-m-d");
        $nuevaFecha = date('Y-m-j', strtotime('+60 day', strtotime($fecha)));

        if (strtotime($fechaActual) > strtotime($nuevaFecha)) {
            if ($this->diff_dte($fechaActual, $fecha) >= 90) {
                $usu = new Usuario();
                $usu->__SET('Usuario_Id', $_SESSION['usu_codigo']);
                $usu->__SET('nUsuEstado', 0);
                $this->usuario_model->Estado($usu);
                $this->CerrarSession();
            }
            return true;
        }
        return false;
    }

    public function CambioClaveCliente()
    {

        require_once 'view/autenticacionCliente.php';
    }

    public function CambioClave()
    {

        require_once 'view/autenticacion.php';
    }

    public function Index2()
    {
        require_once 'view/index.html';
    }

    public function Index()
    {


        if (!isset($_SESSION['usu_autenticado'])) {
            require_once 'view/login.php';
        } else {

            // $claveAnterior = $this->reporte_model->ClaveAnterior($_SESSION['usu_codigo']);
            // $parametro = $this->parametro_model->ListarParametros();
            // $mensaje_cambio_clave = "USTED DEBE DE CAMBIAR SU CLAVE POR FAVOR.";

            // $modal = '';

            // if(count($claveAnterior) > 0){

            //     $modal = ($this->verificarFechaClave($claveAnterior[0]["usucla_fecha"]) == true ? '$("#mensaje").modal("show");' : '');

            // } 


            $_SESSION['usu_autenticado'] = 'Si';
            $_SESSION['usu_codigo'] = '001';
            $_SESSION['usu_personal'] = '1';
            $_SESSION['usu_nombre'] = 'user';
            $_SESSION['usu_login'] = '009';
            $_SESSION['usu_tipo'] = '1';
            $_SESSION['usu_stado'] = 1;
            $estado_usu = true;

            require_once 'view/header.php';
            require_once 'view/webforms/wfaprincipal.php';
            require_once 'view/footer.php';
        }
    }
    public function Index3()
    {

        if (!isset($_SESSION['usu_autenticado'])) {
            require_once 'view/loginc.php';
        } else {

            $claveAnterior = $this->reporte_model->ClaveAnterior($_SESSION['usu_codigo']);
            $parametro = $this->parametro_model->ListarParametros();
            //$mensaje_cambio_clave = "USTED DEBE DE CAMBIAR SU CLAVE POR FAVOR.";

            //$modal = '';

            //if(count($claveAnterior) > 0){

            //     $modal = ($this->verificarFechaClave($claveAnterior[0]["usucla_fecha"]) == true ? '$("#mensajeCliente").modal("show");' : '');

            //}else {

            //    header('location: ?c=Principal&a=CambioClaveCliente');

            //}

            require_once 'view/headercliente.php';
            require_once 'view/webforms/wfaprincipal.php';
            require_once 'view/footer.php';

            //echo "<script type='text/javascript'>
            //            $(document).ready(function (){
            //                $('.inicio').addClass('active');                            
            //                ".$modal."
            //                $('#mensaje_cam_usu_cliente').html('".$mensaje_cambio_clave."');
            //            });
            //     </script>";
        }
    }
    public function verificarUsuario()
    { // em 29-08-2020 //

        $array = array();

        $estado_usu = false;

        //  $_SESSION['usu_autenticado'] = 'Si';
        //  $_SESSION['usu_codigo'] = $row->__GET('Usuario_Id');
        //  $_SESSION['usu_personal'] = $row->__GET('Personal_Id');
        //  $_SESSION['usu_nombre'] = $row->__GET('sUsuNombre');
        //  $_SESSION['usu_login'] = $row->__GET('sUsuLogin');
        //  $_SESSION['usu_tipo'] = $row->__GET('nUsuTipo');
        //  $_SESSION['usu_stado'] = 1;
        //  $estado_usu = true;

        $_SESSION['usu_autenticado'] = 'Si';
        $_SESSION['usu_codigo'] = '001';
        $_SESSION['usu_personal'] = '1';
        $_SESSION['usu_nombre'] = 'user';
        $_SESSION['usu_login'] = '009';
        $_SESSION['usu_tipo'] = '1';
        $_SESSION['usu_stado'] = 1;
        $estado_usu = true;


        if ($estado_usu == true) {

            if ($_POST['usuario'] == 'administrador' && $_POST['clave'] == '202301') {

                //  $biusu = new Bitacorausuario();

                //  $biusu->__SET('nBiusuTipoModulo', 1);
                //  $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
                //  $biusu->__SET('nBiusuDescripcion', 'Inicio Sessión');
                //  $this->bitacorausuario_model->guardarBitacorausuario($biusu);

                $array = array("Estado" => 1);
            } else {
                $array = array("Estado" => 2);
            }
        }

        print_r(json_encode($array));
    }
    public function CerrarSession()
    {
        // $biusu = new Bitacorausuario();
        // $biusu->__SET('nBiusuTipoModulo', 1);
        // $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
        // $biusu->__SET('nBiusuDescripcion', 'Cerro Sessión');
        // $this->bitacorausuario_model->guardarBitacorausuario($biusu);
        session_destroy();
        echo '<script type="text/javascript">window.location="http://hormiguita.pe/hormiguipanel/?c=Principal&a=Index";</script>';
    }

    public function CambiarClave()
    {
        $data = new Usuario();
        $data->__SET('Usuario_Id', $_SESSION['usu_codigo']);
        $data->__SET('sUsuContrasena', $_POST['sUsuContrasena']);
        $this->usuario_model->Claves($data);
    }

    public function CambiarClaveCliente()
    {
        $data = new Clientes();
        $data->__SET('Cliente_Id', $_SESSION['usu_codigo']);
        $data->__SET('sCliPassword', $_POST['sCliPassword']);
        $this->usuario_model->ClavesClientes($data);
    }

    public function ListarConstantes()
    {
        $data = $this->fm_constantes_model->Buscar($_POST['nConCodigo']);
        print_r(json_encode($data));
    }

    public function verificarCliente()
    { /* usado anteriormente */

        $estado = array("estado" => 0);

        if ($_POST['usu_nombre'] != "" && $_POST['usu_clave'] != "") {
            //$autenticar = $this->distibuidor_usuario_model->autenticarUsuario($_POST['usu_nombre'], $_POST['usu_clave']); 
            $autenticar = $this->distribuidor_model->Autenticar($_POST['usu_nombre'], $_POST['usu_clave']); //original
            //print_r(json_encode($autenticar));
            if ($_SESSION['captcha'] == $_POST['codigocaptcha']) {

                if (count($autenticar) > 0) {

                    foreach ($autenticar as $r) {

                        if ($r->__GET('nDisOculto') == 0) {

                            $_SESSION['usu_autenticado'] = 'Si';
                            $_SESSION['usu_codigo'] = $r->__GET('Distribuidor_Id');
                            $_SESSION['usu_nombre'] = $r->__GET('sDisNombre');
                            $_SESSION['usu_login'] = $r->__GET('sDisUsuario');
                            $_SESSION['usu_stado'] = 0;

                            $biusu = new Bitacorausuario();
                            $biusu->__SET('nBiusuTipoModulo', 2);
                            $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
                            $biusu->__SET('nBiusuDescripcion', 'Inicio Sessión');
                            $this->bitacorausuario_model->guardarBitacorausuario($biusu);

                            $estado = array("estado" => 1);
                        }

                        if ($r->__GET('nDisEstado') == 0) {

                            $estado = array("estado" => 2);
                        }
                    }
                } else {

                    array("estado" => 2);
                }
            } else {

                array("estado" => 4);
            }
        } else {

            array("estado" => 5);
        }

        print_r(json_encode($estado));
    }
    public function verificarCliente2()
    { /* em 08-09-20 */

        $estado = array("estado" => 0);

        if ($_POST['usu_nombre'] != "" && $_POST['usu_clave'] != "") {
            $autenticar = $this->distibuidor_usuario_model->autenticarUsuario($_POST['usu_nombre'], $_POST['usu_clave']);
            //$autenticar = $this->distribuidor_model->Autenticar($_POST['usu_nombre'], $_POST['usu_clave']); //original

            if ($_SESSION['captcha'] == $_POST['codigocaptcha']) {

                if (count($autenticar) > 0) {

                    foreach ($autenticar as $r) {

                        if ($r->__GET('nDisUsuEliminado') == 0) {

                            $_SESSION['usu_autenticado'] = 'Si';
                            $_SESSION['usu_codigo'] = $r->__GET('distribuidor_usuario_id');
                            $_SESSION['usu_nombre'] = $r->__GET('sDisUsuUsuario');
                            $_SESSION['usu_login'] = $r->__GET('sDisUsuContrasena');
                            $_SESSION['usu_nDisUsuUsuario_Id'] = $r->__GET('nDisUsuUsuario_Id'); // em 05-11-2020
                            $_SESSION['usu_stado'] = 0;
                            $estado = array("estado" => 1);

                            $biusu = new Bitacorausuario();
                            $biusu->__SET('nBiusuTipoModulo', 2);
                            $biusu->__SET('nBiusuUsuario_Id', $_SESSION['usu_codigo']);
                            $biusu->__SET('nBiusuDescripcion', 'Inicio Sessión');
                            $this->bitacorausuario_model->guardarBitacorausuario($biusu);
                        }

                        if ($r->__GET('nDisUsuEstado') == 0) {

                            $estado = array("estado" => 2);
                        }
                    }
                } else {

                    array("estado" => 2);
                }
            } else {

                array("estado" => 4);
            }
        } else {

            array("estado" => 5);
        }

        print_r(json_encode($estado));
    }
    public function sesiones()
    {
        print_r($_SESSION);
    }
}
