<section class="content-header">
    <h1>
        Reenvio de comprobantes
        <small></small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="index.php?c=Principal&a=Index"><i class="fa fa-home"></i> Inicio</a></li>
        <li><a href="#">Reenvio de comprobantes</a></li>
    </ol>
</section>

<section class="content">
    <div id="reenvioCombrobantes"></div>
    <div class="row">
        <div class="col-xs-12">
            <div class="box box-success ">
                <div class="box-header" style="padding:10px 25px;">
                    <div class="row">
                        <div class="col-xs-12">
                            <h3 class="box-title" style="margin-bottom: 10px;">
                                Lista de las Empresas
                            </h3>
                            <select name="rucEmpresa" id="rucEmpresa" class="form-control selectpicker" data-live-search="true">
                                <option value="" disabled selected>--Seleccione una empresa--</option>
                                <?php foreach ($empresas as $r) : ?>
                                    <option value="<?= $r['Ruc'] ?>"><?= $r['Empresa'] ?></option>
                                <?php endforeach; ?>
                            </select>
                        </div>
                    </div>
                </div>

                <!-- Datos de la empresa -->
                <div class="box-body" style="padding:0px 25px;">
                    <h4 class="box-title" style="margin-bottom: 20px;">
                        Datos de la empresa
                    </h4>
                    <div class="row">
                        <div class="col-xs-12">
                            <div class="row">
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="empresa" class="form-label">Nombre de la Empresa</label>
                                    <input type="text" id="empresa" class="form-control" placeholder="Nombre de la empresa" disabled>
                                </div>
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="login" class="form-label">Email de la empresa</label>
                                    <input type="email" id="login" class="form-control" placeholder="Email de la empresa" disabled>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="password" class="form-label">Password de la empresa</label>
                                    <input type="password" id="password" class="form-control" placeholder="Password de la empresa" disabled>
                                </div>
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="code" class="form-label">Codigo de la empresa</label>
                                    <input type="text" id="code" class="form-control" placeholder="Codigo de la empresa" disabled>
                                    <input type="hidden" id="dbname">
                                </div>
                            </div>
                        </div>
                        <!-- Boton Enviar -->
                        <div class="box-footer" style="padding: 0 15px 10px 15px; ">
                            <button type="button" onclick="Enviar()" id="btnEnviar" class="btn btn-success" disabled>Enviar</button>
                        </div>
                    </div>
                    <hr>

                    <!-- Modal -->
                    <div class="modal fade" id="miModal" tabindex="-1" role="dialog" aria-labelledby="miModalLabel" aria-hidden="true">
                        <div class="modal-dialog modal-lg">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h4 class="modal-title" id="miModalLabel">Lista de comprobantes Reenviados</h4>
                                </div>
                                <div class="modal-body" style="max-height: calc(100vh - 210px); overflow-y: auto;">
                                    <!-- Tabla -->
                                    <table class="table table-bordered table-striped table-hover text-center">
                                        <thead>
                                            <tr>
                                                <th>MovimientoId</th>
                                                <th>Data</th>
                                            </tr>
                                        </thead>
                                        <tbody id="tbodyReenvioComprobante">
                                        </tbody>
                                    </table>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-primary" data-dismiss="modal">Aceptar</button>
                                </div>
                            </div>
                        </div>
                    </div>


                </div>
            </div>
        </div>
    </div>

</section>


<script type="text/javascript">
    let btnRucEmpresa = $('#rucEmpresa');
    let empresa = $('#empresa');
    let login = $('#login');
    let password = $('#password');
    let cod_e = $('#code');
    let dbname = $('#dbname');
    btnRucEmpresa.on('change', function() {
        valorRuc = $(this).val();

        $.ajax({
            url: '?c=Enterprise&a=ObtenerEmpresaPorRuc',
            type: 'POST',
            data: {
                ruc: valorRuc.trim()
            },
            success: function(data) {
                let result = JSON.parse(data);
                if (Object.keys(result).length) {
                    empresa.val(result.Name);
                    login.val(result.Login);
                    password.val(result.Password);
                    cod_e.val(result.Code);
                    dbname.val(result.NameDB);
                    $("#btnEnviar").attr('disabled', false);
                } else {
                    empresa.val('');
                    login.val('');
                    password.val('');
                    cod_e.val('');
                    dbname.val('');
                    $("#btnEnviar").attr('disabled', true);
                }
            },
            error: function(error) {
                console.log(error);
            }
        });

    });
</script>

<script type="text/javascript">
    let btnEnviar = $('#btnEnviar');

    function Enviar() {
        $('#preloader').fadeIn('slow');
        let usuario = $('#login').val();
        let clave = $('#password').val();
        let code = 'FelipeXMarroquin2020';

        // http://localhost/Bauner
        $.post('https://hormiguitala.com/?c=Principal&a=verificarUsuario', {
                usuario,
                clave,
                codigocaptcha: code,
            },
            function(data, status) {
                if (status === "success") {
                    //Agregar al div
                    if (data.includes('alert-warning')) {
                        var htmlString = data;
                        var div = $(htmlString).filter('.alert-warning');
                        var alertDiv = `<div class="alert alert-warning" role="alert">${div.html()}</div>`;
                        $('#reenvioCombrobantes').append(alertDiv);
                        $('#preloader').fadeOut('slow');
                    }
                    console.log(status);
                    //enviarcomprobantes();
                } else {
                    let alertDiv = `<div class="alert alert-danger alert-dismissible fade in" role="alert">
                                         <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                             <span aria-hidden="true">&times;</span>
                                        </button>
                                        <strong>Error no controlado en el servidor!</strong> Por favor, intente nuevamente más tarde.
                                    </div>`
                    $('#reenvioCombrobantes').append(alertDiv);
                    $('#preloader').fadeOut('slow');
                }
            }
        );
    }

    function enviarcomprobantes() {
        var movimientos = [];
        var enviado = false;
        let html = '';
        let dbname = $('#dbname').val();
        $.post('?c=Enterprise&a=ObtenerIdMovimientos', {
            dbname
        }, function(data) {
            movimientos = JSON.parse(data);
            for (var i = 0; i < movimientos.length; i++) {
                const promise = new Promise((resolve, reject) => {
                    const movimiento_id = movimientos[i];
                    console.log(movimiento_id, 'acá');
                    setTimeout(() => {
                        // $.post('http://hormiguitala.com/?c=Movimiento&a=enviarcomprobante', {
                        //     Movimiento_Id: movimiento_id
                        // }, function(data) {
                        //     html = `<tr>
                        //             <td>${movimiento_id}</td>
                        //             <td>${data}</td>
                        //         </tr>`;
                        //     $('#tbodyReenvioComprobante').append(html);
                        // });
                        $('#preloader').fadeOut('slow');
                        $('#miModal').modal('show');
                    }, 3000);
                    // if (i === movimientos.length - 1) {
                    //     let alertDiv = `<div class="alert alert-success alert-dismissible fade in" role="alert">
                    //                      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    //                          <span aria-hidden="true">&times;</span>
                    //                     </button>
                    //                     <strong>Exito!</strong> Comprobantes reenviandos correctamente.
                    //                 </div>`
                    //     $('#reenvioCombrobantes').append(alertDiv);
                    // }
                });

            }

        })
    }
</script>