<?php
class EnterpriseModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Verificar($sCliCodigoSAP)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL cli_verificar('$sCliCodigoSAP')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cli = new Clientes();
                $cli->__SET('Cliente_Id', $r->Cliente_Id);
                $cli->__SET('sCliCodigoSAP', $r->sCliCodigoSAP);
                $cli->__SET('sCliNombre', $r->sCliNombre);
                $cli->__SET('sCliRUCDNI', $r->sCliRUCDNI);
                $cli->__SET('sCliTelefono', $r->sCliTelefono);
                $cli->__SET('sCliTelefono2', $r->sCliTelefono2);
                $cli->__SET('sCliCodPais', $r->sCliCodPais);
                $cli->__SET('sCliPais', $r->sCliPais);
                $cli->__SET('sCliDepartamento', $r->sCliDepartamento);
                $cli->__SET('sCliProvincia', $r->sCliProvincia);
                $cli->__SET('sCliDistrito', $r->sCliDistrito);
                $cli->__SET('sCliDireccion', $r->sCliDireccion);
                $cli->__SET('sCliUsuario', $r->sCliUsuario);
                $cli->__SET('sCliPassword', $r->sCliPassword);
                $cli->__SET('sCliGrupoCli', $r->sCliGrupoCli);
                $cli->__SET('nCliEstado', $r->nCliEstado);
                $cli->__SET('nCliOculto', $r->nCliOculto);
                $cli->__SET('dCliFecha_Act', $r->dCliFecha_Act);
                $cli->__SET('nCliUsuario_Id', $r->nCliUsuario_Id);
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ent_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $data = new enterprise();
                $data->__SET("Id",  $r->Id);
                $data->__SET("Code",  $r->Code);
                $data->__SET("Name",  $r->Name);
                $data->__SET("TradeName",  $r->TradeName);
                $data->__SET("Ruc",  $r->Ruc);
                $data->__SET("Address",  $r->Address);
                $data->__SET("UbigeoName",  $r->UbigeoName);
                $data->__SET("UbigeoCode",  $r->UbigeoCode);
                $data->__SET("CTADetraccion",  $r->CTADetraccion);
                $data->__SET("NameDB",  $r->NameDB);
                $data->__SET("UsuarioDB",  $r->UsuarioDB);
                $data->__SET("PasswordDB",  $r->PasswordDB);
                $data->__SET("ServerDB",  $r->ServerDB);
                $data->__SET("Email",  $r->Email);
                $data->__SET("Seal",  $r->Seal);
                $data->__SET("IsFE",  $r->IsFE);
                $data->__SET("Background",  $r->Background);
                $data->__SET("ExoneratedIGV",  $r->ExoneratedIGV);
                $data->__SET("HasResend",  $r->HasResend);
                $data->__SET("Notification",  $r->Notification);
                $data->__SET("Status",  $r->Status);
                $data->__SET("CreationUser",  $r->CreationUser);
                $data->__SET("CreationDate",  $r->CreationDate);
                $data->__SET("UpdateUser",  $r->UpdateUser);
                $data->__SET("UpdateDate",  $r->UpdateDate);
                $result[] = $data;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function ListarNombre()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL dis_listarNombre(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cli = new Distribuidor();
                $cli->__SET('Distribuidor_Id', $r->Distribuidor_Id);
                $cli->__SET('sDisNombre', $r->sDisNombre);
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Buscar($Proveedor_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ent_listar($Proveedor_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $data = new enterprise();

                $data->__SET("Id",  $r->Id);
                $data->__SET("Code",  $r->Code);
                $data->__SET("Name",  $r->Name);
                $data->__SET("TradeName",  $r->TradeName);
                $data->__SET("Ruc",  $r->Ruc);
                $data->__SET("Address",  $r->Address);
                $data->__SET("UbigeoName",  $r->UbigeoName);
                $data->__SET("UbigeoCode",  $r->UbigeoCode);
                $data->__SET("CTADetraccion",  $r->CTADetraccion);
                $data->__SET("NameDB",  $r->NameDB);
                $data->__SET("UsuarioDB",  $r->UsuarioDB);
                $data->__SET("PasswordDB",  $r->PasswordDB);
                $data->__SET("ServerDB",  $r->ServerDB);
                $data->__SET("Email",  $r->Email);
                $data->__SET("Seal",  $r->Seal);
                $data->__SET("IsFE",  $r->IsFE);
                $data->__SET("Background",  $r->Background);
                $data->__SET("ExoneratedIGV",  $r->ExoneratedIGV);
                $data->__SET("HasResend",  $r->HasResend);
                $data->__SET("Notification",  $r->Notification);
                $data->__SET("Status",  $r->Status);
                $data->__SET("CreationUser",  $r->CreationUser);
                $data->__SET("CreationDate",  $r->CreationDate);
                $data->__SET("UpdateUser",  $r->UpdateUser);
                $data->__SET("UpdateDate",  $r->UpdateDate);
                $result[] = $data;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    /* em 30-11-2020 */
    public function Crear(Enterprise $data)
    {
        try {
            $Proveedor_Id = 0;
            $stm = $this->pdo->prepare("CALL ent_crear(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?,?,?,?, ?, @Proveedor_Id)");
            $stm->execute(array(
                $data->__get("Code"),
                $data->__get("Name"),
                $data->__get("TradeName"),
                $data->__get("Ruc"),
                $data->__get("Address"),
                $data->__get("UbigeoName"),
                $data->__get("UbigeoCode"),
                $data->__get("CTADetraccion"),
                $data->__get("NameDB"),
                $data->__get("UsuarioDB"),
                $data->__get("PasswordDB"),
                $data->__get("ServerDB"),
                $data->__get("Email"),
                $data->__get("Seal"),
                $data->__get("IsFE"),
                $data->__get("Background"),
                $data->__get("ExoneratedIGV"),
                $data->__get("HasResend"),
                $data->__get("Notification"),
                $data->__get("Status"),
                $data->__get("UpdateUser")
            ));

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Proveedor_Id = $r->Proveedor_Id;
            }
            return $Proveedor_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    /* em 30-11-20 */
    public function Editar(Enterprise $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL ent_editar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?,?,?,?, ?)");
            $stm->execute(array(
                $data->__get("Id"),
                $data->__get("Code"),
                $data->__get("Name"),
                $data->__get("TradeName"),
                $data->__get("Ruc"),
                $data->__get("Address"),
                $data->__get("UbigeoName"),
                $data->__get("UbigeoCode"),
                $data->__get("CTADetraccion"),
                $data->__get("NameDB"),
                $data->__get("UsuarioDB"),
                $data->__get("PasswordDB"),
                $data->__get("ServerDB"),
                $data->__get("Email"),
                $data->__get("Seal"),
                $data->__get("IsFE"),
                $data->__get("Background"),
                $data->__get("ExoneratedIGV"),
                $data->__get("HasResend"),
                $data->__get("Notification"),
                $data->__get("Status"),
                $data->__get("UpdateUser")
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Proveedor $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL ent_ocultar(?,?)");
            $stm->execute(array($data->__get('Proveedor_Id'), $data->__get('nPrvUsuario_Id')));
            echo "Se elimino correctamente";
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    /* em 09-11-20  cheka q exista codigo */
    public function VerificarCodCliExiste($Cliente_Id, $sCliCodSAP)
    {
        //,$_POST["sEntVIN"]
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL prv_validarCOD($Cliente_Id,'$sCliCodSAP')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = array(
                    'Cliente_Id' => $r->Proveedor_Id,
                    'sCliCodSAP' => $r->sPrvCodigoSAP
                );
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    /* em 09-11-20  cheka q exista codigo */
    public function VerificarRucCliExiste($Cliente_Id, $sCliRUCDNI)
    {
        //,$_POST["sEntVIN"]
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL prv_validarRUCDNI($Cliente_Id,'$sCliRUCDNI')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mov = array(
                    'Cliente_Id' => $r->Proveedor_Id,
                    'sCliRUCDNI' => $r->sPrvRUCDNI
                );
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    function RenderizadoClass($type)
    {
        switch ($type) {
            case 1:
                return 'style="color:#ff0707;"'; // no enviados
            case 2:
                return 'style="color:#ffc107;"'; // no anulados
            case 3:
                return 'style="color:#cc3300;"'; // nc no enviadas
            case 4:
                return 'style="color:black;"';  // gr no envidas
        }
    }

    public function ObtenerComprobantes()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL listar_fact()");
            $stm->execute();
            $i = 0;
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[$i]['Empresa'] = $r->Empresa;
                $result[$i]['Ruc'] = $r->Ruc;
                $result[$i]['Id'] = $r->Id;
                $result[$i]['Fecha'] = $r->Fecha;
                $result[$i]['Correlativo'] = $r->Correlativo;
                $result[$i]['Documento'] = $r->Documento;
                $result[$i]['Estado'] = $r->Estado;
                $result[$i]['EstadoSunat'] = $r->EstadoSunat;
                $result[$i]['Color'] = $this->RenderizadoClass($r->Estado);
                $i++;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerEmpresas()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * FROM enterprise WHERE Status = 1");
            $stm->execute();;
            $i = 0;
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[$i]['Empresa'] = $r->Name;
                $result[$i]['Ruc'] = $r->Ruc;
                $result[$i]['Id'] = $r->Id;
                $result[$i]['Fecha'] = $r->CreationDate;
                $result[$i]['Correlativo'] = $r->Code;
                $result[$i]['Documento'] = $r->UbigeoName;
                $result[$i]['Estado'] = $r->Status;
                $result[$i]['EstadoSunat'] = $r->Status;
                $result[$i]['Color'] = $this->RenderizadoClass($r->Status);
                $i++;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerEmpresaPorRuc($ruc)
    {
        $result = array();

        try {
            $stm = $this->pdo->prepare("select u.Login, u.Password,  e.Code, e.Name from user u
            inner join enterpriseuser eu on eu.UserId=u.Id
            inner join enterprise e on eu.EnterpriseId=e.Id
            where eu.IsDefault=1 and u.Status=1
            and e.Ruc='{$ruc}'
            group by e.Code");

            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result['Login'] = $r->Login;
                $result['Password'] = $r->Password;
                $result['Code'] = $r->Code;
                $result['Name'] = $r->Name;
            }
            return $result;
        } catch (PDOException $e) {
            print "¡Error!: " . $e->getMessage() . "<br/>";
            die();
        }
    }
}
