    <div class="content-wrapper-frm">
        <!-- Content Header (Page header) -->
        <section class="content-header">
            <h1>
                Protocolos
                <small></small>
            </h1>
            <ol class="breadcrumb">
                <li><a href="wfamain.php"><i class="fa fa-dashboard"></i> Inicio</a></li>
                <li><a href="#">Protocolos</a></li>
            </ol>
        </section>        
        <!-- Main content -->
        <section class="content">
            <div class="row">
                <div class="col-xs-12">
                    <div class="box">
                        <div class="box-header">
                            <h3 class="box-title">Relación completa de Protocolos</h3>
                            <div class="row">
                                <div class="col-sm-6">                                    
                                    <form action="?c=Protocologe&a=Index" method="POST" id="FrmFiltrar">
                                        <div class="row">
                                            <div class="col-sm-4 form-group">
                                                <label>Fecha Inicio</label>
                                                <input type="text" class="form-control datepicker" id="FechaInicio" name="FechaInicio" placeholder="DD/MM/YYYY" value="<?php echo $fechaInicio; ?>">
                                            </div>
                                            <div class="col-sm-4 form-group">
                                                <label>Fecha Fin</label>
                                                <input type="text" class="form-control datepicker" id="FechaFin" name="FechaFin" placeholder="DD/MM/YYYY" value="<?php echo $fechaFin; ?>">
                                            </div>
                                            <div class="col-sm-4">
                                                <label style="width: 100%;">&nbsp;</label>
                                                <button type="submit" class="btn btn-primary btn-flat filtrar">Filtrar</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>

                                <?php 
                                switch($_SESSION['usu_tipo']){ 
                                    case '1':
                                    case '2':
                                    case '4':
                                ?>
                                <div class="col-md-6 text-right" style="margin-top: 15px;">
                                    <a class="btn btn-primary btn-flat" id="btn-new-protocologe-frm" style="margin-top: 10px;">Nuevo Protocolo</a>
                                </div>
                                <?php } ?>
                            </div>                            
                        </div><!-- /.box-header -->


                        <div class="box-body">
                            <table id="example1" class="table table-bordered table-striped text-center">
                                <thead>
                                    <tr>
                                        <th>Numero de protocolos</th>
                                        <th>Fecha</th>
                                        <th>Cliente</th>
                                        <th>Producto</th>
                                        <th>Operario</th>
                                        <th>Estado</th>
                                        <th>Operaciones</th>
                                    </tr>
                                </thead> 
                                    
                                <tbody>  
                                    <?php foreach ($protologe as $r): ?>
                                    <?php 

                                    //echo $r->__GET("pro_operador") ;

                                        switch($_SESSION['usu_tipo']){ 
                                            case '4':

                                                if($r->__GET("pro_operador") == $_SESSION['usu_personal']){ 
                                    ?>
                                        <tr> 
                                            <td><?php echo $r->__GET('pro_numero'); ?>                                            
                                            <td><?php echo $r->__GET('pro_fecha'); ?></td>
                                            <td><?php echo $r->__GET('sCliNombre'); ?></td>
                                            <td><?php echo $r->__GET('pro_modeloelectrogeno'); ?></td>
                                            <td><?php echo strtoupper($r->__GET('sProPersonal')); ?></td>
                                            <td><?php echo $this->EstadoProtocologe($r->__GET('EstadoAproPro')); ?></td>
                                            <td>
                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                    case '3':
                                                    case '4':
                                                    case '5':
                                                ?>
                                                <a class="btn btn-danger btn-xs view" title="Ver detalles" href="?c=Protocologe&a=PDF&pro_num=<?php echo $r->__GET("pro_numero"); ?>" target="_blank" ><i class="fa fa-file-text" aria-hidden="true"></i></a>
                                                <?php } ?>
                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                    case '4':
                                                ?>
                                                <?php if($r->__GET('EstadoAproPro') != 1){ ?>
                                                <a class="btn btn-primary btn-xs edit" title="Editar" data-num="<?php echo $r->__GET("pro_numero"); ?>"  onclick="javascript:protocologe.Edit('<?php echo $r->__GET("pro_numero"); ?>');"><i class="fa fa-pencil"></i></a>
                                                <?php } ?>
                                                <?php } ?>

                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                ?>
                                                <button type="button" class="btn btn-danger btn-xs" title="Eliminar" data-toggle="modal" data-target="#modal-eliminar" data-numero="<?php echo $r->__GET("pro_numero"); ?>"><i class="fa fa-trash-o"></i></button>
                                                <?php } ?>

                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '3':
                                                ?>
                                                <button type="button" class="btn btn-primary btn-xs" title="APROBAR Y APERTURAR" data-toggle="modal" data-target="#modal-aproreah" data-numero="<?php echo $r->__GET("Protocologe_Id"); ?>"><i class="fa fa-check-square-o" aria-hidden="true"></i></button>
                                                <?php } ?>
                                            </td>
                                        </tr>
                                    <?php 
                                                }
                                            break;
                                        default:  
                                    ?>
                                            <tr> 
                                            <td><?php echo $r->__GET('pro_numero'); ?></td>
                                            <td><?php echo $r->__GET('pro_fecha'); ?></td>
                                            <td><?php echo $r->__GET('sCliNombre'); ?></td>
                                            <td><?php echo $r->__GET('pro_modeloelectrogeno'); ?></td>
                                            <td><?php echo strtoupper($r->__GET('sProPersonal')); ?></td>
                                            <td><?php echo $this->EstadoProtocologe($r->__GET('EstadoAproPro')); ?></td>
                                            <td>
                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                    case '3':
                                                    case '4':
                                                    case '5':
                                                    case '10':
                                                    case '11':
                                                ?>
                                                <a class="btn btn-danger btn-xs view" title="Ver detalles" href="?c=Protocologe&a=PDF&pro_num=<?php echo $r->__GET("pro_numero"); ?>" target="_blank" ><i class="fa fa-file-text" aria-hidden="true"></i></a>
                                                <?php } ?>
                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                    case '4':
                                                ?>
                                                <?php if($r->__GET('EstadoAproPro') != 1){ ?>
                                                <a class="btn btn-primary btn-xs edit" title="Editar" data-num="<?php echo $r->__GET("pro_numero"); ?>"  onclick="javascript:protocologe.Edit('<?php echo $r->__GET("pro_numero"); ?>');"><i class="fa fa-pencil"></i></a>
                                                <?php } ?>
                                                <?php } ?>

                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '2':
                                                ?>
                                                <button type="button" class="btn btn-danger btn-xs" title="Eliminar" data-toggle="modal" data-target="#modal-eliminar" data-numero="<?php echo $r->__GET("pro_numero"); ?>"><i class="fa fa-trash-o"></i></button>
                                                <?php } ?>

                                                <?php 
                                                switch($_SESSION['usu_tipo']){ 
                                                    case '1':
                                                    case '3':
                                                    case '10':
                                                ?>
                                                <button type="button" class="btn btn-primary btn-xs" title="APROBAR Y APERTURAR" data-toggle="modal" data-target="#modal-aproreah" data-numero="<?php echo $r->__GET("Protocologe_Id"); ?>"><i class="fa fa-check-square-o" aria-hidden="true"></i></button>
                                                <?php } ?>
                                            </td>
                                        </tr>
                                    <?php 
                                        } 
                                    ?>
                                    <?php endforeach; ?>
                                </tbody>
                                <tfoot>                                    
                                    <tr>
                                        <th>Numero de protocolos</th>
                                        <th>Fecha</th>
                                        <th>Cliente</th>
                                        <th>Producto</th>
                                        <th>Operario</th>
                                        <th>Estado</th>                                        
                                        <th>Operario</th>
                                    </tr>
                                </tfoot>
                            </table>


                        </div><!-- /.box-body -->
                        <div class="overlay" style="display: none;">
                            <i class="fa fa-refresh fa-spin"></i>
                        </div>
                    </div><!-- /.box -->
                </div><!-- /.col -->
            </div><!-- /.row -->
        </section><!-- /.content -->
        
        <!-- Modal modal-eliminar -->
        <div class="modal fade" id="modal-eliminar" tabindex="-1" role="dialog" aria-labelledby="modal-eliminar-label" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <form action="?c=Protocologe&a=EliminarProtocologe" method="POST">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Cerrar</span></button>
                            <h4 class="modal-title" id="modal-eliminar-label">Eliminar</h4>
                        </div>
                        <div class="modal-body">
                            <input type="hidden" name="pro_num_eli" id="pro_num_eli" value="">
                            ¿Estás seguro que desea eliminar?
                        </div>
                        <div class="modal-footer">
                            <button type="submit" class="btn btn-primary">Si, eliminar</button>
                            <button type="button" class="btn btn-default" data-dismiss="modal">No, cancelar</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <!-- /Modal modal-eliminar -->
        <!-- Modal modal-eliminar -->
        <div class="modal fade" id="modal-aproreah" tabindex="-1" role="dialog" aria-labelledby="modal-eliminar-label" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <form action="?c=Protocologe&a=AprobarProtocologe" method="POST">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Cerrar</span></button>
                            <h4 class="modal-title" id="modal-eliminar-label">Aprobar o Reaperturar</h4>
                        </div>
                        <div class="modal-body">
                            <input type="hidden" name="protocologe_Id_eli" id="protocologe_Id_eli" value="">
                            ¿Estás seguro que desea APROBAR o REAPERTURAR?
                        </div>
                        <div class="modal-footer">
                            <button type="submit" class="btn btn-danger">Si, Aceptar</button>
                            <button type="button" class="btn btn-default" data-dismiss="modal">No, cancelar</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <!-- /Modal modal-eliminar -->
        <script type="text/javascript">
            $(function() {
                jQuery.fn.dataTableExt.oSort['fecha-asc'] = function(a, b) {
                    var ukDatea = a.split('-');
                    var ukDateb = b.split('-');

                    var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
                    var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

                    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
                };

                jQuery.fn.dataTableExt.oSort['fecha-desc'] = function(a, b) {
                    var ukDatea = a.split('-');
                    var ukDateb = b.split('-');

                    var x = (ukDatea[2] + ukDatea[1] + ukDatea[0]) * 1;
                    var y = (ukDateb[2] + ukDateb[1] + ukDateb[0]) * 1;

                    return ((x < y) ? 1 : ((x > y) ? -1 : 0));
                };
                $("#example1").dataTable({
                    "aLengthMenu": [
                        [10, 15, 25, 50, 100, -1],
                        [10, 15, 25, 50, 100, "All"]
                    ],
                    "iDisplayLength": 10,
                    "oLanguage": {
                        "sLengthMenu": "_MENU_ Records per page",
                        "sInfo": "_START_ - _END_ of _TOTAL_",
                        "sInfoEmpty": "0 - 0 of 0",
                        "oPaginate": {
                            "sPrevious": "Prev",
                            "sNext": "Next"
                        }
                    },
                    "aoColumns":[                        
                        {"bSortable": true},
                        {"sType": "fecha"},
                        {"bSortable": true},
                        {"bSortable": true},
                        {"bSortable": true},
                        {"bSortable": true},
                        {"bSortable": true}
                    ],                    
                    aaSorting: [[1, 'desc']]
                });
            });
            $('#modal-eliminar').on('show.bs.modal', function(event) {
                var button = $(event.relatedTarget); // Button that triggered the modal
                var recipient = button.data('numero'); // Extract info from data-* attributes

                // If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
                // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
                var modal = $(this);
                modal.find('.modal-body input').val(recipient);
            });
            $('#modal-aproreah').on('show.bs.modal', function(event) {
                var button = $(event.relatedTarget); // Button that triggered the modal
                var recipient = button.data('numero'); // Extract info from data-* attributes

                // If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
                // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
                var modal = $(this);
                modal.find('.modal-body input').val(recipient);
            });
        </script>
    </div>
    <script type="text/javascript" src="view/librerias/dist/js/funcionesProtocologe.js"></script>