<section class="content-header">
    <h1>
        Reenvio de comprobantes
        <small></small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="index.php?c=Principal&a=Index"><i class="fa fa-home"></i> Inicio</a></li>
        <li><a href="#">Reenvio de comprobantes</a></li>
    </ol>
</section>

<section class="content">
    <div class="row">
        <div class="col-xs-12">
            <div class="box box-success ">
                <div class="box-header" style="padding:10px 25px;">
                    <div class="row">
                        <div class="col-xs-12">
                            <h3 class="box-title" style="margin-bottom: 10px;">
                                Lista de las Empresas
                            </h3>
                            <select name="rucEmpresa" id="rucEmpresa" class="form-control selectpicker" data-live-search="true">
                                <option value="" disabled selected>--Seleccione una empresa--</option>
                                <?php foreach ($empresas as $r) : ?>
                                    <option value="<?= $r['Ruc'] ?>"><?= $r['Empresa'] ?></option>
                                <?php endforeach; ?>
                            </select>
                        </div>
                    </div>
                </div>

                <!-- Datos de la empresa -->
                <div class="box-body" style="padding:0px 25px;">
                    <h4 class="box-title" style="margin-bottom: 20px;">
                        Datos de la empresa
                    </h4>
                    <div class="row">
                        <div class="col-xs-12">
                            <div class="row">
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="empresa" class="form-label">Nombre de la Empresa</label>
                                    <input type="text" id="empresa" class="form-control" placeholder="Nombre de la empresa" disabled>
                                </div>
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="login" class="form-label">Email de la empresa</label>
                                    <input type="email" id="login" class="form-control" placeholder="Email de la empresa" disabled>
                                </div>
                            </div>
                            <div class="row">
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="password" class="form-label">Password de la empresa</label>
                                    <input type="password" id="password" class="form-control" placeholder="Password de la empresa" disabled>
                                </div>
                                <div class="form-group col-xs-12 col-md-6">
                                    <label for="code" class="form-label">Codigo de la empresa</label>
                                    <input type="text" id="code" class="form-control" placeholder="Codigo de la empresa" disabled>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>


                <!-- Boton Enviar -->
                <div class="box-footer" style="padding: 0 25px 10px 25px; ">
                    <button type="button" id="btnEnviar" class="btn btn-success" disabled>Enviar</button>
                </div>

                <div class="col-md-12" id="resultado"></div>

            </div>
        </div>
    </div>


</section>

<script type="text/javascript">
    let btnRucEmpresa = $('#rucEmpresa');
    let empresa = $('#empresa');
    let login = $('#login');
    let password = $('#password');
    let cod_e = $('#code');

    btnRucEmpresa.on('change', function() {
        valorRuc = $(this).val();

        $.ajax({
            url: '?c=Enterprise&a=ObtenerEmpresaPorRuc',
            type: 'POST',
            data: {
                ruc: valorRuc.trim()
            },
            success: function(data) {
                let result = JSON.parse(data);

                if (Object.keys(result).length) {
                    empresa.val(result.Name);
                    login.val(result.Login);
                    password.val(result.Password);
                    cod_e.val(result.Code);
                    $("#btnEnviar").attr('disabled', false);
                } else {
                    empresa.val('');
                    login.val('');
                    password.val('');
                    cod_e.val('');
                    $("#btnEnviar").attr('disabled', true);
                }
            },
            error: function(error) {
                console.log(error);
            }
        });

    });
</script>

<script type="text/javascript">
    let btnEnviar = $('#btnEnviar');

    btnEnviar.click(function() {
        $('#preloader').fadeIn('slow');
        let usuario = $('#login').val();
        let clave = $('#password').val();

        $.ajax({
            type: "POST",
            url: "http://hormiguitala.com/?c=Principal&a=verificarUsuario",
            data: {
                usuario,
                clave,
            },
            success: function(data, status) {
                enviarcomprobantes();
                $('#preloader').fadeOut('slow');
            },
            error: function(error) {
                $('#preloader').fadeOut('slow');
                console.log(error, 'ERROR');
            }


        })

    })
</script>

<script type="text/javascript">
    function enviarcomprobantes() {
        var movimientos = <?php echo $data; ?>;
        for (var i = 0; i < movimientos.length; i++) {
            const promise = new Promise((resolve, reject) => {
                const movimiento_id = movimientos[i];
                setTimeout(() => {
                    $.post('http://hormiguitala.com/?c=Movimiento&a=enviarcomprobante', {
                        Movimiento_Id: movimiento_id
                    }, function(data) {
                        $("#resultado").append(`<h4>ID_Movimiento: ${movimiento_id}</h4>` + data);
                    });
                }, 3000);
            });
        }
    }
</script>